#!/usr/bin/perl -w

package CiselnaRada;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;

use lib "./";
use lib::Dialog;
use lib::Locks;
use lib::Databaze;

my $MyUI;
my %MyMoney;
my $retcode="";
my $CiselnaRada;
my $Locks;

sub upravit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    my $dissable_ok=0;
    $Locks=0;
    if($where) {
        $Locks=new Locks(%MyMoney);
        if(!$Locks->create_lock('r_CisRady',$where)) {
            $dissable_ok=1;
        };
    };
    return($self->run($dissable_ok, $where,0,%params));
};

sub kopirovat {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    return($self->run(0, $where,1,%params));
};

sub pridat {
    my ($self, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    return($self->run(0,'',0,%params));
};

sub odstranit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('r_CisRady',$where,1)) {
        return(0);
    };
    my $Databaze=new Databaze(%MyMoney);
    if(!$Databaze->Remove("r".$MyMoney{'RokData'}->get('id')."_CisRady",$where)) {
        $Locks->remove_lock;
        return(0);
    };
    $Locks->remove_lock;
    return(1);
};

sub run {
    my ($class, $dissable_ok, $where, $kopie, %params) = @_;
    $retcode=0;
    %MyMoney=%params;
    my $window=$class;
    $MyUI=$class;
    my $self=$class;
    $CiselnaRada=new Table('r_CisRady',%MyMoney);
    if(!$kopie) {
        $class->{'where'}=$where;
    } else {
        $class->{'where'}="";
    };
    if($dissable_ok) {
        $window->FORM->{'button_ok'}->set_sensitive(0);
    };

    if($where) {
        if(!$CiselnaRada->load($where,1)) {
            my $Dialog=new Dialog;
            $Dialog->show("text"=>"Záznam nelze načíst!\nZřejme byl změněn jiným uživatelem.","type"=>"error");
            if($Locks) {
                $Locks->remove_lock;
            };
            return(0);
        };
    };
    $CiselnaRada->WriteToUI($window->FORM);
    
    $MyUI=$window;
    $window->TOPLEVEL->set_title('Číselná řada');
    $MyMoney{'MainCfg'}->window_open("CiselnaRada",$self->TOPLEVEL);
    $MyUI->{'TOPFORM'}=$MyUI->FORM->{'vbox136'};
    $window->TOPLEVEL->show;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    return($retcode);
};

sub on_button_close_clicked {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("CiselnaRada",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_CiselnaRada_unrealize {
    if($Locks) {
        $Locks->remove_lock;
    };
    my $self=shift;
    $MyMoney{'MainCfg'}->window_close("CiselnaRada",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {
    $CiselnaRada->ReadFromUI($MyUI->FORM);
    if(!$CiselnaRada->get('rada')) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Zkratka číselné řady nemůže být prázdná!","type"=>"error");
            return;        
    };
    if($MyUI->{'where'}) {
        if(!$CiselnaRada->update) {
            return;
        };
    } else {
        if(!$CiselnaRada->save(1)) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Záznam nelze uložit!\nZřejmě ukládáte duplicitní klíč.","type"=>"error");
            return;
        };
    };
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("CiselnaRada",$MyUI->TOPLEVEL);
    $retcode=$CiselnaRada;
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_button_stredisko_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('strediska',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat","selected_rows"=>[$MyUI->FORM->{'stred'}->get_text])) {
        my $tbl=new Table('r_SzStred',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'stred'}->set_text($tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'stred'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_volna_cisla_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    $Seznam->run('volna_cisla',"cfg"=>[%MyMoney],"where"=>"rada='".$MyUI->FORM->{'rada'}->get_text."'");
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

1;
