#!/usr/bin/perl -w

package FakturaVystavena;

BEGIN {
    use src::MymoneyUI;
};


use strict;
use POSIX qw(strftime);


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;
use Gtk2::SimpleList;

use lib "./";
use lib::KartaPolozkyFaktury;
use lib::TextyFaktury;
use lib::KorekceFaktury;
use lib::Databaze;
use lib::Locks;
use lib::_DanovaKalkulacka;
use lib::Tools;
use lib::Seznam;
use lib::Printing;


my $MyUI;
my %MyMoney;
my $retcode="";
my $FakturaVystavena;
my @Polozky=();
my $rada;
my $CiselnaRada;
my $dissable_changes=0;
my @blokovane_cislo=();
my $Locks;

sub set_mymoney {
    my $self=shift;
    %MyMoney=@_;
};

sub pridat {
    my ($self, %params)=@_;
    %MyMoney=%params;
    
    my $rada="";
    if($MyMoney{'UzivatelskeNastaveni'}->get('fz_prij_ciselna_rada')) {
        $rada=$MyMoney{'UzivatelskeNastaveni'}->get('fz_prij_ciselna_rada');
    } else {
        my $Seznam=new Seznam;
        if($Seznam->run('ciselne_rady',"cfg"=>[%MyMoney],"ok_butt"=>1,"where"=>"vf='1'","selected_rows_by"=>"rada",selected_rows=>[$MyMoney{'MainCfg'}->get('VF_last_rada')])) {
            my $tbl=new Table('r_CisRady',%MyMoney);
                if($Seznam->selected_where) {
                if($tbl->load($Seznam->selected_where,1)) {
                    $rada=$tbl->get('rada');
                    $MyMoney{'MainCfg'}->set('VF_last_rada',$rada)
                } else {
                    my $Dialog=new Dialog;
                    $Dialog->show("text"=>"Záznam nelze načíst!\nZřejme byl změněn jiným uživatelem.","type"=>"error");
                    $MyUI->{'TOPFORM'}->set_sensitive(1);
                    return;
                };
            };
        } else {
            return(0);
        };
    };
    return($self->run('',$rada));
};

sub upravit {
    my ($self, $where, %params)=@_;
    %MyMoney=%params;
    return($self->run($where,''));
};

my $storno=0;
sub storno {
    my ($self, $where, %params)=@_;
    %MyMoney=%params;
    $storno=1;
    my $retval=$self->run($where,'');
    $storno=0;
    if($retval) {
        my $Faktura=new Table('r_VFaktury',%MyMoney);
        $Faktura->load($MyUI->{'storno_where'});
        return([$Faktura,$retval]);
    } else {
        return(0);
    };
};

my $kopirovat=0;
sub kopirovat {
    my ($self, $where, %params)=@_;
    %MyMoney=%params;
    $kopirovat=1;
    my $retval=$self->run($where,'');
    $kopirovat=0;
    return($retval);
};

sub uzamceni_dokladu {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('r_VFaktury',$where,1)) {
        return(0);
    };
    my $Faktura=new Table('r_VFaktury',%MyMoney);
    if(!$Faktura->load($where,1)) {
        $Locks->remove_lock;
        return(0);
    };
    $Faktura->set('uzamceni',1);
    if(!$Faktura->update) {
        $Locks->remove_lock;
        return(0);        
    };
    $Locks->remove_lock;
    return($Faktura);
};

sub zruseni_zamku {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('r_VFaktury',$where,1)) {
        return(0);
    };
    my $Faktura=new Table('r_VFaktury',%MyMoney);
    if(!$Faktura->load($where,1)) {
        $Locks->remove_lock;
        return(0);
    };
    $Faktura->set('uzamceni',0);
    if(!$Faktura->update) {
        $Locks->remove_lock;
        return(0);        
    };
    $Locks->remove_lock;
    return($Faktura);
};

sub smazat {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    my $LocksS;
    
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('r_VFaktury',$where)) {
        return(0);
    };
    my $Faktura=new Table('r_VFaktury',%MyMoney);
    if(!$Faktura->load($where,1)) {
        $Locks->remove_lock;
        return(0);
    };
    if($Faktura->get('uzamceni')) {
        my $Dialog=new Dialog(%MyMoney);
        $Dialog->show("text"=>"Doklad je uzamčen.\nNeni možné jej smazat.","type"=>"info");
        $Locks->remove_lock;
        return(0);
    };

    if($Faktura->get('storno_t') eq 'S') {
        my $Dialog=new Dialog;
        $Dialog->show('text'=>"Stornovany doklad '".$Faktura->get('doklad')."' nelze smazat!\nNejprve musite smazat doklad stornovaci.",'type'=>'error');
        $Locks->remove_lock;
        return(0);
    };
    
    #
    # pokud byla faktura uhrazena, tak je potreba na to upozornit!
    #
    my $FakturaStornovana=0;
    my $Dialog=new Dialog;
    if(!$Dialog->show('text'=>"Opravdu chcete smazat vystavenou fakturu?",'type'=>'question')) {
        $Locks->remove_lock;
        return(0);        
    } else {
        $Faktura->set('smazano',1);
        # pokud mazeme stornovaci fakturu, tak musime odebrat priznak storno u faktury stornovane
        # tady zacne TRANSAKCE
        if($Faktura->get('storno_t') eq 'V') {
            $FakturaStornovana=new Table('r_VFaktury',%MyMoney);
            $FakturaStornovana->load("storno='".$Faktura->get('cislo')."'");
            $LocksS=new Locks(%MyMoney);
            if(!$LocksS->create_lock('r_VFaktury',"cislo='".$FakturaStornovana->get('cislo')."'")) {
                $Locks->remove_lock;
                return(0);
            };
            $FakturaStornovana->set('storno_t','-');
            $FakturaStornovana->set('storno',0);
            if(!$FakturaStornovana->update) {
                #rollback
                $LocksS->remove_lock;
                $Locks->remove_lock;
                return(0);
            };
        };
        $Faktura->set('storno_t','-');
        $Faktura->set('storno',0);
        if(!$Faktura->update) {
            #rollback
            $Locks->remove_lock;
            if($LocksS) {
                $LocksS->remove_lock;
            };
            return(0);        
        };
        $Locks->remove_lock;
        if($LocksS) {
            $LocksS->remove_lock;
        };
        if($FakturaStornovana) {
            return([$Faktura,$FakturaStornovana]);
        } else {
            return($Faktura);
        };
    };
    #konec TRANSAKCE
};

sub printing {
    my ($class,$seznam,$button,@selected_where,@checked_where)=@_;
    my $MenuFakturyTisk=new MenuFakturyTisk;
    $MenuFakturyTisk->FORM->{'item260'}->signal_connect('activate', "PrintMenuItemClicked", [$seznam,"faktura",@selected_where]);
    $MenuFakturyTisk->FORM->{'item263'}->signal_connect('activate', "PrintMenuItemClicked", [$seznam,"dodaci_list",@selected_where]);
    $MenuFakturyTisk->FORM->{'item265'}->signal_connect('activate', "PrintMenuItemClicked", [$seznam,"danovy_doklad",@selected_where]);
    $MenuFakturyTisk->FORM->{'item270'}->signal_connect('activate', "PrintMenuItemClicked", [$seznam,"kniha_faktur",@selected_where]);
    if(@selected_where) {
        $MenuFakturyTisk->FORM->{'item260'}->set_sensitive(1);
        $MenuFakturyTisk->FORM->{'item263'}->set_sensitive(1);
        $MenuFakturyTisk->FORM->{'item265'}->set_sensitive(1);
        $MenuFakturyTisk->FORM->{'item273'}->set_sensitive(1);
    } else {
        $MenuFakturyTisk->FORM->{'item260'}->set_sensitive(0);
        $MenuFakturyTisk->FORM->{'item263'}->set_sensitive(0);
        $MenuFakturyTisk->FORM->{'item265'}->set_sensitive(0);
        $MenuFakturyTisk->FORM->{'item273'}->set_sensitive(0);
    };
    $MenuFakturyTisk->TOPLEVEL->popup(undef, # parent menu shell
                 undef, # parent menu item
                 undef, # menu pos func
                 undef, # data
                 $button,
                 0);
};

sub print_document {
    my ($self,$doctype,@selected_where)=@_;
    my $template="";
    my @PrintDocuments=();
    my $Printing=new Printing(%MyMoney);
    
    if($doctype eq "kniha_faktur") {
        $template="kniha_faktur.tex";
        my %PrintHash=();
        my $RawLatexDefs="";
        $PrintHash{'mytypdokladu'}='VYSTAVENEF';
        $PrintHash{'myplatcedph'}=$MyMoney{'RokData'}->get('platce_dph');
        $PrintHash{'myvytiskl'}=$MyMoney{'Uzivatel'}->get('jmeno');
        $PrintHash{'jmenoagendy'}=$MyMoney{'AgendaData'}->get('nazev');
        $PrintHash{'icoagendy'}=$MyMoney{'AgendaData'}->get('ico');
        $PrintHash{'ucetnirok'}=$MyMoney{'RokData'}->get('ucetni_rok');
        
        my $kuhrade=0;
        my $zbyvaproplatit=0;
        my $zbyvadobropisy=0;

        # pokud je vybrana jedna, nebo zadna faktura, tak tiskneme vsechny faktury ze seznamu
        if(@selected_where<=1) {
            @selected_where=();
            my $Databaze=new Databaze(%MyMoney);
            $Databaze->Read("r".$MyMoney{'RokData'}->get('id')."_VFaktury","",("cislo"));
            for(my $i=0;$i<$Databaze->numrows;$i++) {
                my %row=$Databaze->fetchhash;
                push(@selected_where,"cislo='".$row{'cislo'}."'");
            };
        };

        if(@selected_where) {
            my %VsechnyFaktury=();
            $RawLatexDefs="\\def\\radky{\n";
            foreach $_ (@selected_where) {
                my $Faktura=new Table('r_VFaktury',%MyMoney);
                $Faktura->load($_);
                $VsechnyFaktury{$Faktura->get('cislo')}=$Faktura;
            };
            foreach my $cislo (sort {$a <=> $b} keys(%VsechnyFaktury)) {
                my $Faktura=$VsechnyFaktury{$cislo};
                my $status="";
                if($Faktura->get('smazano')) {
                    $status="smazano";
                } else {
                    if($Faktura->get('dobropis')) {
                        $status="dobropis";
                    } else {
                        my ($rok,$mesic,$den)=split('-',$Faktura->get('splatno'));
                        $rok-=1900;
                        $mesic--;
                        my $melobytzaplaceno=strftime("%s",(59,59,23,$den,$mesic,$rok));
                        if(($melobytzaplaceno<strftime("%s",localtime)) && ($Faktura->get('proplatit')!=0)) {
                            $status="posplatnosti";
                        };
                    };
                };
                $RawLatexDefs.="  \\radek{".$Printing->ParseToLatex($Faktura->get('doklad'))."}{".$Printing->ParseToLatex(Tools::HumanDate($Faktura->get('vystaveno')))."}{".$Printing->ParseToLatex(Tools::HumanDate($Faktura->get('splatno')))."}{".$Printing->ParseToLatex(Tools::HumanDate($Faktura->get('plnenodph')))."}{".$Printing->ParseToLatex(Tools::HumanNums(sprintf("%01.2f",$Faktura->get('kuhradesdp'))))."}{".$Printing->ParseToLatex(Tools::HumanNums(sprintf("%01.2f",$Faktura->get('proplatit'))))."}{".$Printing->ParseToLatex($Faktura->get('o_nazev'))."}{".$Printing->ParseToLatex($Faktura->get('varsymbol'))."}{".$status."}\n";
                if($status ne "smazano") {
                    $kuhrade+=$Faktura->get('kuhradesdp');
                    if($status ne "dobropis") {
                        $zbyvaproplatit+=$Faktura->get('proplatit');
                    } else {
                        $zbyvadobropisy+=$Faktura->get('proplatit');
                    };
                };
            };
            $RawLatexDefs.="}\n";
        };        

        
        $PrintHash{'celkemkuhrade'}=Tools::HumanNums(sprintf("%01.2f",$kuhrade));
        $PrintHash{'zbyvaproplatit'}=Tools::HumanNums(sprintf("%01.2f",$zbyvaproplatit));
        $PrintHash{'zbyvadobropisy'}=Tools::HumanNums(sprintf("%01.2f",$zbyvadobropisy));
        push(@PrintDocuments,[$RawLatexDefs,%PrintHash]);
    } else {
        foreach $_ (@selected_where) {
            my $Faktura=new Table('r_VFaktury',%MyMoney);
            $Faktura->load($_);
            my %PrintHash=();
    
            # prirazeni klicu pro tisk dokladu
            
            # typ dokladu
            if($doctype eq "faktura") {
                $PrintHash{'mytypdokladu'}="FAKTURA";
                $template="faktura.tex";
            };
            if($doctype eq "dodaci_list") {
                $PrintHash{'mytypdokladu'}="DODACILIST";
                $template="faktura.tex";
            };
            if($doctype eq "danovy_doklad") {
                $template="prijmovy_danovy_doklad.tex";
            };
            
            #typ faktury
            if($Faktura->get('druh') eq "0") {
                $PrintHash{'mytypfaktury'}="NORMALNI";
            };
            if($Faktura->get('druh') eq "1") {
                $PrintHash{'mytypfaktury'}="PROFORMOVA";
            };
            if($Faktura->get('druh') eq "2") {
                $PrintHash{'mytypfaktury'}="ZALOHOVA";
            };
    
            #platce dph
            $PrintHash{'myplatcedph'}=$MyMoney{'RokData'}->get('platce_dph');
    
    
            $PrintHash{'myvytiskl'}=$MyMoney{'Uzivatel'}->get('jmeno');
            $PrintHash{'myvystavil'}=$Faktura->get('vystavil');
    
            $PrintHash{'myspisovaznacka'}="";
    
            $PrintHash{'mysmazano'}=$Faktura->get('smazano');
            $PrintHash{'mystornotyp'}=$Faktura->get('storno_t');
    
            $PrintHash{'myfakturapopis'}=$Faktura->get('popis');
            
            $PrintHash{'mydodavatelnazev'}=$Faktura->get('d_nazev');
            $PrintHash{'mydodavatelulice'}=$Faktura->get('d_ulice');
            $PrintHash{'mydodavatelpsc'}=$Faktura->get('d_psc');
            $PrintHash{'mydodavatelmesto'}=$Faktura->get('d_mesto');
            $PrintHash{'mydodavatelstat'}=$Faktura->get('d_stat');
            $PrintHash{'mydodavateltel'}=$Faktura->get('d_telpred')." ".$Faktura->get('d_telcislo')." ".$Faktura->get('d_telklap');
            $PrintHash{'mydodavatelfax'}=$Faktura->get('d_faxpred')." ".$Faktura->get('d_faxcislo')." ".$Faktura->get('d_faxklap');
            $PrintHash{'mydodavatelmobil'}=$Faktura->get('d_mobilpre')." ".$Faktura->get('d_mobilcis');
            $PrintHash{'mydodavatelemail'}=$Faktura->get('d_email');
            $PrintHash{'mydodavatelwww'}=$Faktura->get('d_www');
            $PrintHash{'mydodavatelico'}=$Faktura->get('d_ico');
            $PrintHash{'mydodavateldic'}=$Faktura->get('d_dic');
            $PrintHash{'mydodavatelbanka'}=$Faktura->get('bankazkrat');
            $PrintHash{'mydodavatelucet'}=$Faktura->get('cislouctu');
            $PrintHash{'mydodavatelkodbanky'}=$Faktura->get('kodbanky');
            $PrintHash{'myzpusobdopravy'}=$Faktura->get('zpdopravy');
            $PrintHash{'myfakturacislo'}=$Faktura->get('doklad');
            $PrintHash{'myobjednavkacislo'}=$Faktura->get('cobjednavky');
            $PrintHash{'myksym'}=$Faktura->get('konsym');
            $PrintHash{'myvarsym'}=$Faktura->get('varsymbol');
            $PrintHash{'myspecsym'}=$Faktura->get('specsymbol');
    
            $PrintHash{'myodberatelico'}=$Faktura->get('o_ico');
            $PrintHash{'myodberateldic'}=$Faktura->get('o_dic');
            $PrintHash{'myodberatelnazev'}=$Faktura->get('o_nazev');
            $PrintHash{'myodberateljmenoos'}="";
            $PrintHash{'myodberatelulice'}=$Faktura->get('o_ulice');
            $PrintHash{'myodberatelpsc'}=$Faktura->get('o_psc');
            $PrintHash{'myodberatelmesto'}=$Faktura->get('o_mesto');
            $PrintHash{'myodberatelstat'}=$Faktura->get('o_stat');
    
            $PrintHash{'mykoncnazev'}=$Faktura->get('k_nazev');
            $PrintHash{'mykoncjmenoos'}="";
            $PrintHash{'mykonculice'}=$Faktura->get('k_ulice');
            $PrintHash{'mykoncpsc'}=$Faktura->get('k_psc');
            $PrintHash{'mykoncmesto'}=$Faktura->get('k_mesto');
            $PrintHash{'mykoncstat'}=$Faktura->get('k_stat');
    
            my %ZpusobPlatby=(0=>"hotove", 1=>"převodem", 2=>"složenkou", 3=>"dobírkou", 3=>"platební kartou", 4=>"zápočtem");
            $PrintHash{'myzpusobplatby'}=$ZpusobPlatby{$Faktura->get('uhrada')};
            
            $PrintHash{'mydatumvystaveni'}=Tools::HumanDate($Faktura->get('vystaveno'));
            $PrintHash{'mydatumsplatnosti'}=Tools::HumanDate($Faktura->get('splatno'));
            $PrintHash{'mydatumplneni'}=Tools::HumanDate($Faktura->get('plnenodph'));
    
            $PrintHash{'mytextpredcenamifak'}=$Faktura->get('textpredfa');
            $PrintHash{'mytextzacenamifak'}=$Faktura->get('textzafa');
            $PrintHash{'mytextpredcenamidod'}=$Faktura->get('textpreddl');
            $PrintHash{'mytextzacenamidod'}=$Faktura->get('textzadl');
    
            $PrintHash{'snizenasazbadph'}=Tools::HumanNums($Faktura->get('sazbadph1'));
            $PrintHash{'zakladnisazbadph'}=Tools::HumanNums($Faktura->get('sazbadph2'));
    
            # 
            # data do tabulky danoveho dokladu
            # 
            $PrintHash{'zakladnula'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('zaklad_0')));
            $PrintHash{'zakladjedna'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('zaklad_1')));
            $PrintHash{'zakladdva'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('zaklad_2')));
            $PrintHash{'zakladtri'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('zaklad_3')));
            $PrintHash{'dphjedna'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('dph_1')));
            $PrintHash{'dphdva'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('dph_2')));
            $PrintHash{'dphtri'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('dph_3')));
            $PrintHash{'celkemnula'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('zaklad_0')));
            $PrintHash{'celkemjedna'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('zaklad_1')+$Faktura->get('dph_1')));
            $PrintHash{'celkemdva'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('zaklad_2')+$Faktura->get('dph_2')));
            $PrintHash{'celkemtri'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('zaklad_3')+$Faktura->get('dph_3')));
            $PrintHash{'zaokzakladnula'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('kzaklad_0')));
            $PrintHash{'zaokzakladjedna'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('kzaklad_1')));
            $PrintHash{'zaokzakladdva'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('kzaklad_2')));
            $PrintHash{'zaokdphjedna'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('kdph_1')));
            $PrintHash{'zaokdphdva'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('kdph_2')));
            $PrintHash{'zaokcelkemnula'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('kzaklad_0')));
            $PrintHash{'zaokcelkemjedna'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('kzaklad_1')+$Faktura->get('kdph_1')));
            $PrintHash{'zaokcelkemdva'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('kzaklad_2')+$Faktura->get('kdph_2')));
            $PrintHash{'zaokcelkemtri'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('kzaklad_0')+$Faktura->get('kzaklad_1')+$Faktura->get('kdph_1')+$Faktura->get('kzaklad_2')+$Faktura->get('kdph_2')));
            $PrintHash{'zaokrozpousteno'}=Tools::HumanNums($Faktura->get('zaokr_rozpoustet'));
    
            #
            # Polozky faktury
            #
            my $Databaze=new Databaze(%MyMoney);
            $Databaze->Read("r".$MyMoney{'RokData'}->get('id')."_VFaktPol","faktura_cislo='".$Faktura->get('cislo')."'",("id","poradi"));
            @Polozky=();
            for(my $i=0;$i<$Databaze->numrows;$i++) {
                my %row=$Databaze->fetchhash;
                $Polozky[$row{'poradi'}-1]=new Table('r_VFaktPol',%MyMoney);
                $Polozky[$row{'poradi'}-1]->load("id='".$row{'id'}."'");
            };
    
            my $celkovyzaklad=0;
            my $celkovyzakladkuhrade=0;
            my $RawLatexDefs="";
            if(@Polozky) {
                $RawLatexDefs="\\def\\polozkyfaktury{\n";
                foreach my $Polozka (@Polozky) {
                    my $sazbadph="";
                    if($Polozka->get('sazbadph') eq "0") {
                        $sazbadph=0;
                    } else {
                        $sazbadph=$Faktura->get('sazbadph'.$Polozka->get('sazbadph'));
                    };
                    $RawLatexDefs.="    \\polozka{".$Printing->ParseToLatex($Polozka->get('popis'))."}{".$Printing->ParseToLatex($Polozka->get('katalog'))."}{".$Printing->ParseToLatex(Tools::HumanNums(sprintf("%01.4f",$Polozka->get('pocetmj'))))."}{".$Printing->ParseToLatex($Polozka->get('textmj'))."}{".$Printing->ParseToLatex(Tools::HumanNums(sprintf("%01.2f",$Polozka->get('mjzaklad')-($Polozka->get('mjzaklad')*($Faktura->get('sleva')*0.01)))))."}{".$Printing->ParseToLatex(Tools::HumanNums($sazbadph))."}{".$Printing->ParseToLatex(Tools::HumanNums(sprintf("%01.2f",$Polozka->get('celkemzaklad')-($Polozka->get('celkemzaklad')*($Faktura->get('sleva')*0.01)))))."}{".$Printing->ParseToLatex(Tools::HumanNums(sprintf("%01.2f",$Polozka->get('celkemvcdph')-($Polozka->get('celkemvcdph')*($Faktura->get('sleva')*0.01)))))."}{".$Printing->ParseToLatex($Polozka->get('pozn'))."}\n";
                    $celkovyzakladkuhrade+=($Polozka->get('mjzaklad')-($Polozka->get('mjzaklad')*($Faktura->get('sleva')*0.01)))*$Polozka->get('pocetmj');
                    my $cenamj=0;
                    # bez dph, jen zaklad
                    if(($Polozka->get('typceny') eq 0) || ($Polozka->get('typceny') eq 3)) {
                        $cenamj=$Polozka->get('cenamj');
                    };
                    # s dph
                    if($Polozka->get('typceny') eq 1) {
                        $cenamj=($Polozka->get('cenamj')/(1+$sazbadph*0.01));
                    };
                    # jen dph
                    if($Polozka->get('typceny') eq 2) {
                        $cenamj=($Polozka->get('cenamj')/$sazbadph)*100;
                    };
                    $celkovyzaklad+=$cenamj*$Polozka->get('pocetmj');
                };
                $RawLatexDefs.="}\n";
            };
            
            
            #
            # data do tabulky celkove sumarizace faktury
            #
            my $sleva=$Faktura->get('sleva');
            if(($celkovyzaklad-$celkovyzakladkuhrade)!=0) {
                $sleva=$Faktura->get('sleva')+(($celkovyzaklad-$celkovyzakladkuhrade)/($celkovyzaklad/100));
            };
            $PrintHash{'mysleva'}=Tools::HumanNums(sprintf("%01.2f",$sleva));
            $PrintHash{'mycenacelkem'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('kuhradesdp')));
            $PrintHash{'myuhrazenozalohou'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('zaplaceno')));;
            $PrintHash{'myzbyvauhradit'}=Tools::HumanNums(sprintf("%01.2f",$Faktura->get('proplatit')));;
    
            push(@PrintDocuments,[$RawLatexDefs,%PrintHash]);
        };
    };
    $Printing->print_document($template,@PrintDocuments);
};

my $first_init;

sub run {
    my ($class,$where,$rada_zkrat)=@_;

    $retcode=0;
    my $window=$class;
    $MyUI=$class;
    @Polozky=();
    $first_init=1;
    
    $MyUI->{'TOPFORM'}=$MyUI->FORM->{'vbox212'};
    
    # inicializace okna   
    $MyUI->FORM->{'eventbox_smazany'}->modify_bg('normal', Gtk2::Gdk::Color->parse('white'));
    $MyUI->FORM->{'eventbox_smazany'}->hide;
    $MyUI->FORM->{'eventbox_stornovany'}->modify_bg('normal', Gtk2::Gdk::Color->parse('white'));
    $MyUI->FORM->{'eventbox_stornovany'}->hide;
    $MyUI->FORM->{'eventbox_stornovaci'}->modify_bg('normal', Gtk2::Gdk::Color->parse('white'));
    $MyUI->FORM->{'eventbox_stornovaci'}->hide;
    $MyUI->FORM->{'eventbox_uzamceny'}->modify_bg('normal', Gtk2::Gdk::Color->parse('white'));
    $MyUI->FORM->{'eventbox_uzamceny'}->hide;
    
    $MyUI->FORM->{'datucpr'}=Gnome2::DateEdit->new (strftime("%s",localtime), 0, 0);
    $MyUI->FORM->{'table101'}->attach($MyUI->FORM->{'datucpr'}, 1, 2, 0, 1, ['fill'], ['fill', 'expand'], 0, 0);
    $MyUI->FORM->{'datucpr'}->set_size_request(96, 24);
    $MyUI->FORM->{'datucpr'}->show;

    $MyUI->FORM->{'plnenodph'}=Gnome2::DateEdit->new (strftime("%s",localtime), 0, 0);
    $MyUI->FORM->{'table101'}->attach($MyUI->FORM->{'plnenodph'}, 1, 2, 1, 2, ['fill'], ['fill', 'expand'], 0, 0);
    $MyUI->FORM->{'plnenodph'}->set_size_request(96, 24);
    $MyUI->FORM->{'plnenodph'}->show;

    $MyUI->FORM->{'datskpoh'}=Gnome2::DateEdit->new (strftime("%s",localtime), 0, 0);
    $MyUI->FORM->{'table101'}->attach($MyUI->FORM->{'datskpoh'}, 1, 2, 2, 3, ['fill'], ['fill', 'expand'], 0, 0);
    $MyUI->FORM->{'datskpoh'}->set_size_request(96, 24);
    $MyUI->FORM->{'datskpoh'}->show;

    $MyUI->FORM->{'vystaveno'}=Gnome2::DateEdit->new (strftime("%s",localtime), 0, 0);
    $MyUI->FORM->{'table101'}->attach($MyUI->FORM->{'vystaveno'}, 3, 4, 0, 1, ['fill'], ['fill', 'expand'], 0, 0);
    $MyUI->FORM->{'vystaveno'}->set_size_request(96, 24);
    $MyUI->FORM->{'vystaveno'}->show;

    $MyUI->FORM->{'splatno'}=Gnome2::DateEdit->new (strftime("%s",localtime), 0, 0);
    $MyUI->FORM->{'table101'}->attach($MyUI->FORM->{'splatno'}, 3, 4, 1, 2, ['fill'], ['fill', 'expand'], 0, 0);
    $MyUI->FORM->{'splatno'}->set_size_request(96, 24);
    $MyUI->FORM->{'splatno'}->show;

    $MyUI->FORM->{'doruceno'}=Gnome2::DateEdit->new (strftime("%s",localtime), 0, 0);
    $MyUI->FORM->{'table101'}->attach($MyUI->FORM->{'doruceno'}, 3, 4, 2, 3, ['fill'], ['fill', 'expand'], 0, 0);
    $MyUI->FORM->{'doruceno'}->set_size_request(96, 24);
    $MyUI->FORM->{'doruceno'}->show;

    $MyUI->FORM->{'datumits'}=Gnome2::DateEdit->new (strftime("%s",localtime), 0, 0);
    $MyUI->FORM->{'table109'}->attach($MyUI->FORM->{'datumits'}, 3, 4, 2, 3, ['fill'], ['fill', 'expand'], 0, 0);
    $MyUI->FORM->{'datumits'}->set_size_request(96, 24);
    $MyUI->FORM->{'datumits'}->show;

    # list seznamu faktur
    $MyUI->FORM->{'seznam_polozek'} = Gtk2::SimpleList->new('Pořadí'=>'int','Popis'=>'text','Počet MJ'=>'text','MJ'=>'text','Sazba DPH'=>'text','Cena'=>'text','Typ ceny'=>'text','Sleva %'=>'text','Katalogové číslo'=>'text','Předkontace'=>'text','Členění DPH'=>'text','Činnost'=>'text','Zakázka'=>'text','Středisko'=>'text');
    $MyUI->FORM->{'seznam_polozek'}->set_headers_visible('1');
    $MyUI->FORM->{'seznam_polozek'}->get_selection->signal_connect('changed',"seznam_polozek_selection_changed");
    $MyUI->FORM->{'seznam_polozek'}->signal_connect("row-activated"=>"on_button_opravit_clicked");
    $MyUI->FORM->{'scrolledwindow31'}->add($MyUI->FORM->{'seznam_polozek'});
    $MyUI->FORM->{'seznam_polozek'}->show;

    $MyUI->create_menu_pridat;

    $MyUI->FORM->{'_danova_kalkulacka'}=new _DanovaKalkulacka;
    $MyUI->FORM->{'_danova_kalkulacka'}->init;
    $MyUI->FORM->{'_danova_kalkulacka'}->reparent($window->FORM->{'hbox_danova_kalkulacka'});
    $MyUI->FORM->{'_danova_kalkulacka'}->show;
    $MyUI->FORM->{'_danova_kalkulacka'}->signal_connect("vcdph3_changed","FakturaVystavena::celkova_cena_changed",$MyUI);

    if($MyMoney{'RokData'}->get('platce_dph')) {
        $MyUI->FORM->{'_danova_kalkulacka'}->show_dph(1);
        $MyUI->FORM->{'zjednd'}->show;
        $MyUI->FORM->{'label594'}->show;
        $MyUI->FORM->{'plnenodph'}->show;
        $MyUI->FORM->{'label624'}->show;
        $MyUI->FORM->{'hbox389'}->show;
        $MyUI->FORM->{'_danova_kalkulacka'}->show;
    } else {
        $MyUI->FORM->{'zjednd'}->hide;
        $MyUI->FORM->{'label594'}->hide;
        $MyUI->FORM->{'plnenodph'}->hide;
        $MyUI->FORM->{'label624'}->hide;
        $MyUI->FORM->{'hbox389'}->hide;
        $MyUI->FORM->{'_danova_kalkulacka'}->show_dph(0);
    };



    $FakturaVystavena=new Table('r_VFaktury',%MyMoney);
    if($where) {
        #
        # Upraveni faktury, kopie, storno
        #
        #
        $FakturaVystavena->load($where);
        $MyUI->FORM->{'_danova_kalkulacka'}->set_sazbydph($FakturaVystavena->get('sazbadph1'),$FakturaVystavena->get('sazbadph1'));
        if($storno) {
            my $Dialog=new Dialog;
            if(!$Dialog->show('text'=>"Skutecne si prejete vytvorit stornovaci doklad k dokladu ".$FakturaVystavena->get('doklad')."?",'type'=>'question')) {
                if($Locks) {
                    $Locks->remove_lock;
                };
                return(0);
            };
        };
        $MyUI->FORM->{'doklad'}->set_sensitive(0);
        $MyUI->FORM->{'button_volnecisla'}->set_sensitive(0);
        $MyUI->FORM->{'button_vratitciselnouradu'}->hide;
        $MyUI->FORM->{'button_ciselnarada'}->show;
        $MyUI->FORM->{'button_ciselnarada'}->set_sensitive(0);
        my $Databaze=new Databaze(%MyMoney);
        $Databaze->Read("r".$MyMoney{'RokData'}->get('id')."_VFaktPol","faktura_cislo='".$FakturaVystavena->get('cislo')."'",("id","poradi"));
        for(my $i=0;$i<$Databaze->numrows;$i++) {
            my %row=$Databaze->fetchhash;
            $Polozky[$row{'poradi'}-1]=new Table('r_VFaktPol',%MyMoney);
            $Polozky[$row{'poradi'}-1]->load("id='".$row{'id'}."'");
            if($kopirovat) {
                $Polozky[$row{'poradi'}-1]->set('id',0);
            };
            if($storno) {
                $Polozky[$row{'poradi'}-1]->set('id',0);
                $Polozky[$row{'poradi'}-1]->set('cenamj',$Polozky[$row{'poradi'}-1]->get('cenamj')*-1);
                $Polozky[$row{'poradi'}-1]->set('mjzaklad',$Polozky[$row{'poradi'}-1]->get('mjzaklad')*-1);
                $Polozky[$row{'poradi'}-1]->set('mjdph',$Polozky[$row{'poradi'}-1]->get('mjdph')*-1);
                $Polozky[$row{'poradi'}-1]->set('mjvcdph',$Polozky[$row{'poradi'}-1]->get('mjvcdph')*-1);
                $Polozky[$row{'poradi'}-1]->set('celkemzaklad',$Polozky[$row{'poradi'}-1]->get('celkemzaklad')*-1);
                $Polozky[$row{'poradi'}-1]->set('celkemdph',$Polozky[$row{'poradi'}-1]->get('celkemdph')*-1);
                $Polozky[$row{'poradi'}-1]->set('celkemvcdph',$Polozky[$row{'poradi'}-1]->get('celkemvcdph')*-1);
            };
        };
        if(($kopirovat) || ($storno)) {
            if($storno) {
                $MyUI->{'storno_where'}=$where;
            };
            $where='';
            $FakturaVystavena->set('cislo',0);
            $FakturaVystavena->set('smazano',0);
            my $storno_dokladu=$FakturaVystavena->get('doklad');
            $FakturaVystavena->set('doklad','');
            $FakturaVystavena->set('varsymbol','');
            if($storno) {
                $FakturaVystavena->set('storno_t','V');
                $FakturaVystavena->set('popis',"*** Storno faktury ".$storno_dokladu." *** \"".$FakturaVystavena->get('popis')."\"");
            } else {
                $FakturaVystavena->set('storno_t','-');
            };
            $FakturaVystavena->set('udoklad','');
            $FakturaVystavena->set('uzamceni',0);
            $FakturaVystavena->set('zaplaceno',0);
            $FakturaVystavena->set('vyuctovano',0);
            $FakturaVystavena->set('vystavil','');
            $FakturaVystavena->set('vystavil_id',0);
            $FakturaVystavena->set('prikuhrady',"0001-01-01");  #?
            $FakturaVystavena->set('priuhrzbyv',0); #?
            $FakturaVystavena->set('dateupom1',"0001-01-01");   #?
            $FakturaVystavena->set('dateupom2',"0001-01-01");   #?
            $FakturaVystavena->set('dateupoml',"0001-01-01");   #?
            $FakturaVystavena->set('sumzaloha',0);
            $FakturaVystavena->set('sumzalohac',0);
            $FakturaVystavena->set('datucpr',strftime("%Y-%m-%d",localtime($MyMoney{'MainMenu'}->FORM->{'ucetni_datum'}->get_time)));
            $FakturaVystavena->set('plnenodph',strftime("%Y-%m-%d",localtime($MyMoney{'MainMenu'}->FORM->{'ucetni_datum'}->get_time)));
            $FakturaVystavena->set('datskpoh',strftime("%Y-%m-%d",localtime($MyMoney{'MainMenu'}->FORM->{'ucetni_datum'}->get_time)));
            $FakturaVystavena->set('vystaveno',strftime("%Y-%m-%d",localtime($MyMoney{'MainMenu'}->FORM->{'ucetni_datum'}->get_time)));
            $FakturaVystavena->set('splatno',strftime("%Y-%m-%d",localtime($MyMoney{'MainMenu'}->FORM->{'ucetni_datum'}->get_time+($MyMoney{'RokData'}->get('splatnost_pohledavek')*86400))));
            #$FakturaVystavena->set('doruceno',strftime("%Y-%m-%d",localtime($MyMoney{'MainMenu'}->FORM->{'ucetni_datum'}->get_time)));
            $FakturaVystavena->set('doruceno',"0001-01-01");
            $FakturaVystavena->set('datumits',strftime("%Y-%m-%d",localtime($MyMoney{'MainMenu'}->FORM->{'ucetni_datum'}->get_time)));
            if($FakturaVystavena->get('cisrada')) {
                $MyUI->nastavit_ciselnou_radu($FakturaVystavena->get('cisrada'));
            } else {
                my $rada_zkrat="";
                my $Seznam=new Seznam;
                if($Seznam->run('ciselne_rady',"cfg"=>[%MyMoney],"ok_butt"=>1,"where"=>"vf='1'","selected_rows_by"=>"rada",selected_rows=>[$MyMoney{'MainCfg'}->get('VF_last_rada')])) {
                    my $tbl=new Table('r_CisRady',%MyMoney);
                        if($Seznam->selected_where) {
                        if($tbl->load($Seznam->selected_where,1)) {
                            $rada_zkrat=$tbl->get('rada');
                            $MyMoney{'MainCfg'}->set('VF_last_rada',$rada)
                        } else {
                            my $Dialog=new Dialog;
                            $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                            $MyUI->{'TOPFORM'}->set_sensitive(1);
                            return;
                        };
                    };
                };
                if($rada_zkrat) {
                    $MyUI->nastavit_ciselnou_radu($rada_zkrat);
                } else {
                    $CiselnaRada=0;
                    $MyUI->FORM->{'doklad'}->set_sensitive(1);
                    $MyUI->FORM->{'button_volnecisla'}->set_sensitive(0);
                    $MyUI->FORM->{'button_vratitciselnouradu'}->hide;
                    $MyUI->FORM->{'button_ciselnarada'}->show;
                    $FakturaVystavena->set('cisrada','');
                    $FakturaVystavena->set('cisradacislo',0);
                };
            };
        };
    } else {
        # nova faktura
        
        #datumy
        $FakturaVystavena->set('datucpr',strftime("%Y-%m-%d",localtime($MyMoney{'MainMenu'}->FORM->{'ucetni_datum'}->get_time)));
        $FakturaVystavena->set('plnenodph',strftime("%Y-%m-%d",localtime($MyMoney{'MainMenu'}->FORM->{'ucetni_datum'}->get_time)));
        $FakturaVystavena->set('datskpoh',strftime("%Y-%m-%d",localtime($MyMoney{'MainMenu'}->FORM->{'ucetni_datum'}->get_time)));
        $FakturaVystavena->set('vystaveno',strftime("%Y-%m-%d",localtime($MyMoney{'MainMenu'}->FORM->{'ucetni_datum'}->get_time)));
        $FakturaVystavena->set('splatno',strftime("%Y-%m-%d",localtime($MyMoney{'MainMenu'}->FORM->{'ucetni_datum'}->get_time+($MyMoney{'RokData'}->get('splatnost_pohledavek')*86400))));
        #$FakturaVystavena->set('doruceno',strftime("%Y-%m-%d",localtime($MyMoney{'MainMenu'}->FORM->{'ucetni_datum'}->get_time)));
        $FakturaVystavena->set('datumits',strftime("%Y-%m-%d",localtime($MyMoney{'MainMenu'}->FORM->{'ucetni_datum'}->get_time)));
        
        $MyUI->dodavatel_setup;
        $MyUI->d_faktadresa_setup;
        
        my $hotovostni_faktura=0;
        if(!$hotovostni_faktura) {
            $FakturaVystavena->set('ucet',$MyMoney{'UzivatelskeNastaveni'}->get('ucet'));
            $FakturaVystavena->set('predkontace',$MyMoney{'UzivatelskeNastaveni'}->get('fz_prij_predkontace'));
            $FakturaVystavena->set('cleneni',$MyMoney{'UzivatelskeNastaveni'}->get('fz_prij_cleneni'));
        } else {
            $FakturaVystavena->set('ucet',$MyMoney{'UzivatelskeNastaveni'}->get('pokladna'));
            $FakturaVystavena->set('predkontace',$MyMoney{'UzivatelskeNastaveni'}->get('fp_prij_predkontace'));
            $FakturaVystavena->set('cleneni',$MyMoney{'UzivatelskeNastaveni'}->get('fp_prij_cleneni'));
        };
        $FakturaVystavena->set('stredisko',$MyMoney{'UzivatelskeNastaveni'}->get('stredisko'));
        $FakturaVystavena->set('zakazka',$MyMoney{'UzivatelskeNastaveni'}->get('zakazka'));
        $FakturaVystavena->set('cinnost',$MyMoney{'UzivatelskeNastaveni'}->get('cinnost'));
        
        $FakturaVystavena->set('sazbadph1',$MyMoney{'RokData'}->get('snizena_sazba_dph'));
        $FakturaVystavena->set('sazbadph2',$MyMoney{'RokData'}->get('zakladni_sazba_dph'));
        
        $MyUI->FORM->{'_danova_kalkulacka'}->set_sazbydph($FakturaVystavena->get('sazbadph1'),$FakturaVystavena->get('sazbadph1'));
        
        if($rada_zkrat) {
            $MyUI->nastavit_ciselnou_radu($rada_zkrat);
        } else {
            $CiselnaRada=0;
            $MyUI->FORM->{'doklad'}->set_sensitive(1);
            $MyUI->FORM->{'button_volnecisla'}->set_sensitive(0);
            $MyUI->FORM->{'button_vratitciselnouradu'}->hide;
            $MyUI->FORM->{'button_ciselnarada'}->show;
            $FakturaVystavena->set('cisrada','');
            $FakturaVystavena->set('cisradacislo',0);
        };
        
        $FakturaVystavena->set('zaokr_dph',$MyMoney{'RokData'}->get('fak_p_zaokr_dph'));
        $FakturaVystavena->set('zaokr_dph_m',$MyMoney{'RokData'}->get('fak_p_zaokr_dph_m'));
        $FakturaVystavena->set('zaokr_celk',$MyMoney{'RokData'}->get('fak_p_zaokr_celk'));
        $FakturaVystavena->set('zaokr_celk_m',$MyMoney{'RokData'}->get('fak_p_zaokr_celk_m'));
        $FakturaVystavena->set('zaokr_rozpoustet',$MyMoney{'RokData'}->get('fak_p_zaokr_celk_rozp'));

    };

    #
    # Tohle uz zase plati pro vsechny typy operaci
    #

    if(!@Polozky) {
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value("z0",$FakturaVystavena->get('zaklad_0'));
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value("z1",$FakturaVystavena->get('zaklad_1'));
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value("z2",$FakturaVystavena->get('zaklad_2'));
    };

    if($FakturaVystavena->get('smazano')) {
        $MyUI->FORM->{'eventbox_smazany'}->show;
        $MyUI->FORM->{'button_ok'}->set_sensitive(0);
    };
    if($FakturaVystavena->get('storno_t') eq 'S') {
        $MyUI->FORM->{'eventbox_stornovany'}->show;
    };
    if($FakturaVystavena->get('storno_t') eq 'V') {
        $MyUI->FORM->{'eventbox_stornovaci'}->show;
    };


    $Locks=0;
    if($FakturaVystavena->get('uzamceni')) {
        $MyUI->FORM->{'eventbox_uzamceny'}->show;
        $MyUI->FORM->{'button_ok'}->set_sensitive(0);
        my $Dialog=new Dialog(%MyMoney);
        $Dialog->show("text"=>"Doklad je uzamčen.\nProvedené změny nebude možné ukládat.","type"=>"info");
    } else {
        if($where && !$kopirovat) {
            $Locks=new Locks(%MyMoney);
            if(!$Locks->create_lock('r_VFaktury',$where)) {
                $MyUI->FORM->{'button_ok'}->set_sensitive(0);
            };
        };
    };


    $MyUI->FORM->{'_danova_kalkulacka'}->set_sazbydph($FakturaVystavena->get('sazbadph1'),$FakturaVystavena->get('sazbadph2'));

    $dissable_changes=1;
    $FakturaVystavena->WriteToUI($MyUI->FORM);
    $dissable_changes=0;
    $MyUI->on_doklad_changed;
    
    #intrastat
    if(!$MyMoney{'RokData'}->get('vest_intrastat')) {
        $MyUI->FORM->{'notebook21'}->remove_page(1);
    };
    
    $MyUI->init;
    
    $window->TOPLEVEL->set_title('Faktura vystavená');
    $MyMoney{'MainCfg'}->window_open("FakturaVystavena",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    $first_init=0;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    return($retcode);
};

sub init {
    if($FakturaVystavena->get('korekcecen')) {
        $MyUI->FORM->{'_danova_kalkulacka'}->freeze;
    } else {
        $MyUI->FORM->{'_danova_kalkulacka'}->unfreeze;
    };
    if(!(@Polozky)) {
        $MyUI->FORM->{'label642'}->hide;
        $MyUI->FORM->{'label643'}->hide;
        $MyUI->FORM->{'sleva'}->hide;
        $MyUI->FORM->{'scrolledwindow31'}->hide;
        $MyUI->FORM->{'button_korekce'}->set_sensitive(0);
        $MyUI->FORM->{'_danova_kalkulacka'}->set_editable(1);
        $FakturaVystavena->set('korekcecen',0);
        $MyUI->FORM->{'dobropis'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'dobropis'}->set_sensitive(0);
        $MyUI->FORM->{'label642'}->show;
        $MyUI->FORM->{'label643'}->show;
        $MyUI->FORM->{'sleva'}->show;
        $MyUI->FORM->{'scrolledwindow31'}->show;
        $MyUI->FORM->{'button_korekce'}->set_sensitive(1);
        $MyUI->FORM->{'_danova_kalkulacka'}->set_editable(0);

        $MyUI->FORM->{'seznam_polozek'}->get_selection->set_mode('none');
        @{$MyUI->FORM->{'seznam_polozek'}->{data}}=();
        my @typceny=("bez DPH","s DPH","jen DPH","jen základ");
        my @sazbadph=("0 %",$FakturaVystavena->get('sazbadph1')." %",$FakturaVystavena->get('sazbadph2')." %");
        my $ceny_0=0;
        my $ceny_1=0;
        my $ceny_2=0;
        foreach my $polozka (@Polozky) {
            push(@{$MyUI->FORM->{'seznam_polozek'}->{data}},[$polozka->get('poradi'),$polozka->get('popis'),sprintf("%01.4f",$polozka->get('pocetmj')),$polozka->get('textmj'),$sazbadph[$polozka->get('sazbadph')],sprintf("%01.2f",$polozka->get('cenamj')),$typceny[$polozka->get('typceny')],sprintf("%01.2f",$polozka->get('sleva')),$polozka->get('katalog'),$polozka->get('predkontace'),$polozka->get('cleneni'),$polozka->get('cinnost'),$polozka->get('zakazka'),$polozka->get('stredisko')]);
            if($polozka->get('sazbadph') eq 0) {
                $ceny_0+=$polozka->get('celkemzaklad');
            };
            if($polozka->get('sazbadph') eq 1) {
                $ceny_1+=$polozka->get('celkemzaklad');
            };
            if($polozka->get('sazbadph') eq 2) {
                $ceny_2+=$polozka->get('celkemzaklad');
            };
        };
        $MyUI->FORM->{'seznam_polozek'}->get_selection->set_mode('single');
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value('z0',(($ceny_0/100)*(100-$MyUI->FORM->{'sleva'}->get_value)));
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value('z1',(($ceny_1/100)*(100-$MyUI->FORM->{'sleva'}->get_value)));
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value('z2',(($ceny_2/100)*(100-$MyUI->FORM->{'sleva'}->get_value)));
    };
#    $MyUI->sloupcovy_soucet;
    $MyUI->seznam_polozek_selection_changed;
    if($FakturaVystavena->get('korekcecen')) {
        $MyUI->FORM->{'image128'}->show;
        $MyUI->FORM->{'image139'}->hide;
        
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value('z0',$FakturaVystavena->get('zaklad_0'));
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value('z1',$FakturaVystavena->get('zaklad_1'));
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value('z2',$FakturaVystavena->get('zaklad_2'));
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value('z3',$FakturaVystavena->get('zaklad_0')+$FakturaVystavena->get('zaklad_1')+$FakturaVystavena->get('zaklad_2'));
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value('dph1',$FakturaVystavena->get('dph_1'));
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value('dph2',$FakturaVystavena->get('dph_2'));
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value('dph3',$FakturaVystavena->get('dph_1')+$FakturaVystavena->get('dph_2'));
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value('vcdph0',$FakturaVystavena->get('zaklad_0'));
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value('vcdph1',$FakturaVystavena->get('zaklad_1')+$FakturaVystavena->get('dph_1'));
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value('vcdph2',$FakturaVystavena->get('zaklad_2')+$FakturaVystavena->get('dph_2'));
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value('vcdph3',$FakturaVystavena->get('zaklad_0')+$FakturaVystavena->get('zaklad_1')+$FakturaVystavena->get('zaklad_2')+$FakturaVystavena->get('dph_1')+$FakturaVystavena->get('dph_2'));
    } else {
        $FakturaVystavena->set('kzaklad_0',0);
        $FakturaVystavena->set('kzaklad_1',0);
        $FakturaVystavena->set('kzaklad_2',0);
        $FakturaVystavena->set('kdph_1',0);
        $FakturaVystavena->set('kdph_2',0);
        $MyUI->FORM->{'image128'}->hide;
        $MyUI->FORM->{'image139'}->show;
    };
    $MyUI->on_dobropis_toggled;
    if($MyUI->FORM->{'ucet'}->get_text) {  
        $MyUI->FORM->{'cislouctu'}->set_sensitive(0);
        $MyUI->FORM->{'kodbanky'}->set_sensitive(0);
        $MyUI->FORM->{'nazevbanky'}->set_sensitive(0);
        $MyUI->FORM->{'bankazkrat'}->set_sensitive(0);
        $MyUI->FORM->{'button_kodbanky'}->set_sensitive(0);
        $MyUI->FORM->{'label612'}->set_sensitive(0);
        $MyUI->FORM->{'label613'}->set_sensitive(0);
        $MyUI->FORM->{'label614'}->set_sensitive(0);
    } else {
        $MyUI->FORM->{'cislouctu'}->set_sensitive(1);
        $MyUI->FORM->{'kodbanky'}->set_sensitive(1);
        $MyUI->FORM->{'nazevbanky'}->set_sensitive(1);
        $MyUI->FORM->{'bankazkrat'}->set_sensitive(1);
        $MyUI->FORM->{'button_kodbanky'}->set_sensitive(1);
        $MyUI->FORM->{'label612'}->set_sensitive(1);
        $MyUI->FORM->{'label613'}->set_sensitive(1);
        $MyUI->FORM->{'label614'}->set_sensitive(1);
    };
    $MyUI->adresy_odberatele;
};

sub d_faktadresa_setup {
    $FakturaVystavena->set('d_nazev',$MyMoney{'AgendaData'}->get('nazev'));
    $MyUI->FORM->{'d_nazev'}->set_text($MyMoney{'AgendaData'}->get('nazev'));
    $FakturaVystavena->set('d_ulice',$MyMoney{'AgendaData'}->get('ulice'));
    $MyUI->FORM->{'d_ulice'}->set_text($MyMoney{'AgendaData'}->get('ulice'));
    $FakturaVystavena->set('d_mesto',$MyMoney{'AgendaData'}->get('mesto'));
    $MyUI->FORM->{'d_mesto'}->set_text($MyMoney{'AgendaData'}->get('mesto'));
    $FakturaVystavena->set('d_psc',$MyMoney{'AgendaData'}->get('psc'));
    $MyUI->FORM->{'d_psc'}->set_text($MyMoney{'AgendaData'}->get('psc'));
    $FakturaVystavena->set('d_stat',$MyMoney{'AgendaData'}->get('stat'));    
    $MyUI->FORM->{'d_stat'}->set_text($MyMoney{'AgendaData'}->get('stat'));    
};

sub dodavatel_setup {
    $FakturaVystavena->set('d_telpred',$MyMoney{'AgendaData'}->get('tel_pred'));
    $MyUI->FORM->{'d_telpred'}->set_text($MyMoney{'AgendaData'}->get('tel_pred'));
    $FakturaVystavena->set('d_telcislo',$MyMoney{'AgendaData'}->get('tel'));
    $MyUI->FORM->{'d_telcislo'}->set_text($MyMoney{'AgendaData'}->get('tel'));
    $FakturaVystavena->set('d_telklap',$MyMoney{'AgendaData'}->get('tel_klapka'));
    $MyUI->FORM->{'d_telklap'}->set_text($MyMoney{'AgendaData'}->get('tel_klapka'));
    $FakturaVystavena->set('d_faxpred',$MyMoney{'AgendaData'}->get('fax_pred'));
    $MyUI->FORM->{'d_faxpred'}->set_text($MyMoney{'AgendaData'}->get('fax_pred'));
    $FakturaVystavena->set('d_faxcislo',$MyMoney{'AgendaData'}->get('fax'));
    $MyUI->FORM->{'d_faxcislo'}->set_text($MyMoney{'AgendaData'}->get('fax'));
    $FakturaVystavena->set('d_faxklap',$MyMoney{'AgendaData'}->get('fax_klapka'));
    $MyUI->FORM->{'d_faxklap'}->set_text($MyMoney{'AgendaData'}->get('fax_klapka'));
    $FakturaVystavena->set('d_mobilpre',$MyMoney{'AgendaData'}->get('mobil_pred'));
    $MyUI->FORM->{'d_mobilpre'}->set_text($MyMoney{'AgendaData'}->get('mobil_pred'));
    $FakturaVystavena->set('d_mobilcis',$MyMoney{'AgendaData'}->get('mobil'));
    $MyUI->FORM->{'d_mobilcis'}->set_text($MyMoney{'AgendaData'}->get('mobil'));
    $FakturaVystavena->set('d_email',$MyMoney{'AgendaData'}->get('email'));
    $MyUI->FORM->{'d_email'}->set_text($MyMoney{'AgendaData'}->get('email'));
    $FakturaVystavena->set('d_www',$MyMoney{'AgendaData'}->get('www'));
    $MyUI->FORM->{'d_www'}->set_text($MyMoney{'AgendaData'}->get('www'));
    $FakturaVystavena->set('d_ico',$MyMoney{'AgendaData'}->get('ico'));
    $MyUI->FORM->{'d_ico'}->set_text($MyMoney{'AgendaData'}->get('ico'));
    $FakturaVystavena->set('d_dic',$MyMoney{'AgendaData'}->get('dic'));
    $MyUI->FORM->{'d_dic'}->set_text($MyMoney{'AgendaData'}->get('dic'));
    $FakturaVystavena->set('d_nazevob',$MyMoney{'AgendaData'}->get('ob_nazev'));
    $MyUI->FORM->{'d_nazevob'}->set_text($MyMoney{'AgendaData'}->get('ob_nazev'));
    $FakturaVystavena->set('d_uliceob',$MyMoney{'AgendaData'}->get('ob_ulice'));
    $MyUI->FORM->{'d_uliceob'}->set_text($MyMoney{'AgendaData'}->get('ob_ulice'));
    $FakturaVystavena->set('d_mestoob',$MyMoney{'AgendaData'}->get('ob_mesto'));
    $MyUI->FORM->{'d_mestoob'}->set_text($MyMoney{'AgendaData'}->get('ob_mesto'));
    $FakturaVystavena->set('d_pscob',$MyMoney{'AgendaData'}->get('ob_psc'));
    $MyUI->FORM->{'d_pscob'}->set_text($MyMoney{'AgendaData'}->get('ob_psc'));
    $FakturaVystavena->set('d_statob',$MyMoney{'AgendaData'}->get('ob_stat'));
    $MyUI->FORM->{'d_statob'}->set_text($MyMoney{'AgendaData'}->get('ob_stat'));
};

sub uvolnit_blokovane_cislo_rady {
    if(@blokovane_cislo) {
        my $VolneCislo=new Table('r_VolneCis',%MyMoney);
        $VolneCislo->load("rada='".$blokovane_cislo[0]."' AND cislo='".$blokovane_cislo[1]."' AND in_use='".$blokovane_cislo[2]."'");
        $VolneCislo->set('in_use',0);
        $VolneCislo->set('blokovano_uzivatelem',0);
        $VolneCislo->set('uzivatel','');
        $VolneCislo->update;
        @blokovane_cislo=();
        $FakturaVystavena->set('cisrada','');
        $FakturaVystavena->set('cisradacislo',0);
        @blokovane_cislo=();
    };
};

sub on_button_close_clicked {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("FakturaVystavena",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    $MyUI->uvolnit_blokovane_cislo_rady;
    Gtk2->main_quit;
};

sub on_FakturaVystavena_unrealize {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("FakturaVystavena",$MyUI->TOPLEVEL);
    $MyUI->uvolnit_blokovane_cislo_rady;
    Gtk2->main_quit;
};

sub on_button_ok_clicked {   
    $MyMoney{'MainCfg'}->window_close("FakturaVystavena",$MyUI->TOPLEVEL);

    $FakturaVystavena->ReadFromUI($MyUI->FORM);
    $FakturaVystavena->set('zaklad_0',$MyUI->FORM->{'_danova_kalkulacka'}->get_value('z0'));
    $FakturaVystavena->set('zaklad_1',$MyUI->FORM->{'_danova_kalkulacka'}->get_value('z1'));
    $FakturaVystavena->set('zaklad_2',$MyUI->FORM->{'_danova_kalkulacka'}->get_value('z2'));
    $FakturaVystavena->set('zaklad_3',$MyUI->FORM->{'_danova_kalkulacka'}->get_value('z3'));
    $FakturaVystavena->set('dph_1',$MyUI->FORM->{'_danova_kalkulacka'}->get_value('dph1'));
    $FakturaVystavena->set('dph_2',$MyUI->FORM->{'_danova_kalkulacka'}->get_value('dph2'));
    $FakturaVystavena->set('dph_3',$MyUI->FORM->{'_danova_kalkulacka'}->get_value('dph3'));
    # tohle by melo probehnout jako chranena TRANSAKCE
    if(!$FakturaVystavena->get('cislo')) {
        $FakturaVystavena->set('vystavil',$MyMoney{'Uzivatel'}->get('jmeno'));
        $FakturaVystavena->set('vystavil_id',$MyMoney{'Uzivatel'}->get('id'));
        $FakturaVystavena->set('datvyst',strftime("%Y-%m-%d",localtime));
        $FakturaVystavena->set('casvyst',strftime("%T",localtime));
        $FakturaVystavena->save;
    } else {
        $FakturaVystavena->update;
    };
    my $where_pol="";
    foreach my $polozka (@Polozky) {
        if($polozka->get('id')) {
            $polozka->update;
        } else {
            $polozka->set('faktura_cislo',$FakturaVystavena->get('cislo'));
            $polozka->save;
        };
        if($where_pol) {
            $where_pol.=", ";
        };
        $where_pol.=$polozka->get('id');
    };
    # odstranit smazane polozky
    
    my $Databaze=new Databaze(%MyMoney);
    if($where_pol) {
        $Databaze->Remove("r".$MyMoney{'RokData'}->get('id')."_VFaktPol","faktura_cislo='".$FakturaVystavena->get('cislo')."' AND id NOT IN(".$where_pol.")");
    } else {
        $Databaze->Remove("r".$MyMoney{'RokData'}->get('id')."_VFaktPol","faktura_cislo='".$FakturaVystavena->get('cislo')."'");
    };
    
    if(@blokovane_cislo) {
        my $Databaze=new Databaze(%MyMoney);
        $Databaze->Remove("r".$MyMoney{'RokData'}->get('id')."_VolneCis","rada='".$blokovane_cislo[0]."' AND cislo='".$blokovane_cislo[1]."' AND in_use='".$blokovane_cislo[2]."'");
    };
    
    #pokud prave vystavujeme storno doklad, tak udelame zmenu v dokladu stornovanem
    if($storno) {
        my $StornovanaFaktura=new Table('r_VFaktury',%MyMoney);
        $StornovanaFaktura->load($MyUI->{'storno_where'});
        $StornovanaFaktura->set('storno',$FakturaVystavena->get('cislo'));
        $StornovanaFaktura->set('storno_t','S');
        $StornovanaFaktura->update;
    };
    # konec TRANSAKCE
    if($Locks) {
        $Locks->remove_lock;
    };
    @blokovane_cislo=();
    
    $MyUI->TOPLEVEL->hide;
    $retcode=$FakturaVystavena;
    Gtk2->main_quit;
};


sub on_button_texty_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $TextyFaktury=new TextyFaktury;
    if((my @texty=$TextyFaktury->run($FakturaVystavena->get('textpredfa'),$FakturaVystavena->get('textzafa'),$FakturaVystavena->get('textpreddl'),$FakturaVystavena->get('textzadl'),%MyMoney))) {
        $FakturaVystavena->set('textpredfa',$texty[0]);
        $FakturaVystavena->set('textzafa',$texty[1]);
        $FakturaVystavena->set('textpreddl',$texty[2]);
        $FakturaVystavena->set('textzadl',$texty[3]);
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_korekce_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $KorekceFaktury=new KorekceFaktury;

    my $ceny_0=0;
    my $ceny_1=0;
    my $ceny_2=0;
    foreach my $polozka (@Polozky) {
        if($polozka->get('sazbadph') eq 0) {
            $ceny_0+=$polozka->get('celkemzaklad');
        };
        if($polozka->get('sazbadph') eq 1) {
            $ceny_1+=$polozka->get('celkemzaklad');
        };
        if($polozka->get('sazbadph') eq 2) {
            $ceny_2+=$polozka->get('celkemzaklad');
        };
    };

    $ceny_0=(($ceny_0/100)*(100-$MyUI->FORM->{'sleva'}->get_value));
    $ceny_1=(($ceny_1/100)*(100-$MyUI->FORM->{'sleva'}->get_value));
    $ceny_2=(($ceny_2/100)*(100-$MyUI->FORM->{'sleva'}->get_value));
    my $dph_1=$ceny_1*(0.01*$FakturaVystavena->get('sazbadph1'));
    my $dph_2=$ceny_2*(0.01*$FakturaVystavena->get('sazbadph2'));
    
    my %val=(
             "cfg"=>[%MyMoney],
             "zaklad_0"=>$ceny_0,
             "zaklad_1"=>$ceny_1,
             "zaklad_2"=>$ceny_2,
             "dph_1"=>$dph_1,
             "dph_2"=>$dph_2,
             "kzaklad_0"=>$FakturaVystavena->get('kzaklad_0'),
             "kzaklad_1"=>$FakturaVystavena->get('kzaklad_1'),
             "kzaklad_2"=>$FakturaVystavena->get('kzaklad_2'),
             "kdph_1"=>$FakturaVystavena->get('kdph_1'),
             "kdph_2"=>$FakturaVystavena->get('kdph_2'),
             "sazbadph1"=>$FakturaVystavena->get('sazbadph1'),
             "sazbadph2"=>$FakturaVystavena->get('sazbadph2'),
             "zaokr_dph"=>$FakturaVystavena->get('zaokr_dph'),
             "zaokr_dph_m"=>$FakturaVystavena->get('zaokr_dph_m'),
             "zaokr_celk"=>$FakturaVystavena->get('zaokr_celk'),
             "zaokr_celk_m"=>$FakturaVystavena->get('zaokr_celk_m'),
             "zaokr_rozpoustet"=>$FakturaVystavena->get('zaokr_rozpoustet')
            );
    if($KorekceFaktury->run(%val)) {
        %val=$KorekceFaktury->get_values;
        if($val{'korekce_nastavena'}) {
            $FakturaVystavena->set('zaklad_0',$val{'zaklad_0'}+$val{'kzaklad_0'});
            $FakturaVystavena->set('zaklad_1',$val{'zaklad_1'}+$val{'kzaklad_1'});
            $FakturaVystavena->set('zaklad_2',$val{'zaklad_2'}+$val{'kzaklad_2'});
            $FakturaVystavena->set('dph_1',$val{'dph_1'}+$val{'kdph_1'});
            $FakturaVystavena->set('dph_2',$val{'dph_2'}+$val{'kdph_2'});
            $FakturaVystavena->set('kzaklad_0',$val{'kzaklad_0'});
            $FakturaVystavena->set('kzaklad_1',$val{'kzaklad_1'});
            $FakturaVystavena->set('kzaklad_2',$val{'kzaklad_2'});
            $FakturaVystavena->set('kdph_1',$val{'kdph_1'});
            $FakturaVystavena->set('kdph_2',$val{'kdph_2'});
            $FakturaVystavena->set('korekcecen',1);
        } else {
            $FakturaVystavena->set('kzaklad_0',0);
            $FakturaVystavena->set('kzaklad_1',0);
            $FakturaVystavena->set('kzaklad_2',0);
            $FakturaVystavena->set('kdph_1',0);
            $FakturaVystavena->set('kdph_2',0);
            $FakturaVystavena->set('korekcecen',0);
        };
        $FakturaVystavena->set('zaokr_dph',$val{'zaokr_dph'});
        $FakturaVystavena->set('zaokr_dph_m',$val{'zaokr_dph_m'});
        $FakturaVystavena->set('zaokr_celk',$val{'zaokr_celk'});
        $FakturaVystavena->set('zaokr_celk_m',$val{'zaokr_celk_m'});
        $FakturaVystavena->set('zaokr_rozpoustet',$val{'zaokr_rozpoustet'});
        $MyUI->init;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_konsym_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $select_row=$MyUI->FORM->{'konsym'}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('VF_last_konsym');
    };
    if($Seznam->run('konstantni_symboly',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"konsym",selected_rows=>[$select_row])) {
        my $tbl=new Table('g_SzKonSym',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'konsym'}->set_text($tbl->get('konsym'));
                $MyMoney{'MainCfg'}->set('VF_last_konsym',$tbl->get('konsym'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'konsym'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_ucet_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $select_row=$MyUI->FORM->{'ucet'}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('VF_last_ucet');
    };
    if($Seznam->run('ucty_pokladny',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$select_row])) {
        my $tbl=new Table('r_SzUcPokl',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'ucet'}->set_text($tbl->get('zkrat'));
                if($tbl->get('ucpokl') eq 'U') {
                    $MyUI->FORM->{'cislouctu'}->set_text($tbl->get('ucet'));
                    $MyUI->FORM->{'kodbanky'}->set_text($tbl->get('bkod'));
                    $MyUI->FORM->{'nazevbanky'}->set_text($tbl->get('bnazev'));
                    $MyUI->FORM->{'bankazkrat'}->set_text($tbl->get('bzkrat'));
                } else {
                    $MyUI->FORM->{'cislouctu'}->set_text('');
                    $MyUI->FORM->{'kodbanky'}->set_text('');
                    $MyUI->FORM->{'nazevbanky'}->set_text('');
                    $MyUI->FORM->{'bankazkrat'}->set_text('');
                };
                $MyMoney{'MainCfg'}->set('VF_last_ucet',$tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'ucet'}->set_text('');
        };
    };
    $MyUI->init;
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_stredisko_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $select_row=$MyUI->FORM->{'stredisko'}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('VF_last_stredisko');
    };
    if($Seznam->run('strediska',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$select_row])) {
        my $tbl=new Table('r_SzStred',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'stredisko'}->set_text($tbl->get('zkrat'));
                $MyMoney{'MainCfg'}->set('VF_last_stredisko',$tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'stredisko'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_cinnost_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $select_row=$MyUI->FORM->{'cinnost'}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('VF_last_cinnost');
    };
    if($Seznam->run('cinnosti',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$select_row])) {
        my $tbl=new Table('r_SzCinn',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'cinnost'}->set_text($tbl->get('zkrat'));
                $MyMoney{'MainCfg'}->set('VF_last_cinnost',$tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'cinnost'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_zakazka_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $select_row=$MyUI->FORM->{'zakazka'}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('VF_last_zakazka');
    };
    if($Seznam->run('zakazky',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$select_row])) {
        my $tbl=new Table('r_Zakazky',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'zakazka'}->set_text($tbl->get('zkrat'));
                $MyMoney{'MainCfg'}->set('VF_last_zakazka',$tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'zakazka'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_predkontace_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $where="typ='0'";
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'J') {
        $where="typ='P'";
    };
    my $Seznam=new Seznam;
    my $select_row=$MyUI->FORM->{'predkontace'}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('VF_last_predkontace');
    };
    if($Seznam->run('predkontace_'.$MyMoney{'RokData'}->get('typ_ucetnictvi'),"cfg"=>[%MyMoney],"ok_butt"=>1,"where"=>$where,"selected_rows_by"=>"zkrat",selected_rows=>[$select_row])) {
        my $tbl=new Table('r_UcPrKont_'.$MyMoney{'RokData'}->get('typ_ucetnictvi'),%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'predkontace'}->set_text($tbl->get('zkrat'));
                $MyMoney{'MainCfg'}->set('VF_last_predkontace',$tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'predkontace'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_cleneni_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $select_row=$MyUI->FORM->{'cleneni'}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('VF_last_cleneni');
    };
    if($Seznam->run('cleneni',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$select_row])) {
        my $tbl=new Table('r_UcClnDPH',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'cleneni'}->set_text($tbl->get('zkrat'));
                $MyMoney{'MainCfg'}->set('VF_last_cleneni',$tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'cleneni'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_kodbanky_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $select_row=$MyUI->FORM->{'kodbanky'}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('VF_last_kodbanky');
    };
    if($Seznam->run('banky',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"kod",selected_rows=>[$select_row])) {
        my $tbl=new Table('g_Banky',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'kodbanky'}->set_text($tbl->get('kod'));
                $MyUI->FORM->{'nazevbanky'}->set_text($tbl->get('nazev'));
                $MyUI->FORM->{'bankazkrat'}->set_text($tbl->get('zkrat'));
                $MyMoney{'MainCfg'}->set('VF_last_kodbanky',$tbl->get('kod'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'kodbanky'}->set_text('');
            $MyUI->FORM->{'nazevbanky'}->set_text('');
            $MyUI->FORM->{'bankazkrat'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

my $in_on_dobropis_toggled=0;
sub on_dobropis_toggled {
    if(!$in_on_dobropis_toggled) {
        $in_on_dobropis_toggled=1;
        if($MyUI->FORM->{'dobropis'}->get_active) {
            if($MyMoney{'RokData'}->get('platce_dph')) {
                $MyUI->FORM->{'doruceno'}->show;
                $MyUI->FORM->{'label656'}->show;
            };
            $MyUI->FORM->{'image137'}->show;
            $MyUI->FORM->{'image138'}->show;
        } else {
            $MyUI->FORM->{'doruceno'}->hide;
            $MyUI->FORM->{'label656'}->hide;
            $MyUI->FORM->{'image137'}->hide;
            $MyUI->FORM->{'image138'}->hide;
        };
        $MyUI->init;
        $in_on_dobropis_toggled=0;
    };
};

sub seznam_polozek_selection_changed {
    #if($MyUI->FORM->{'seznam_polozek'}->get_selection->get_selected) {
    #    $MyUI->FORM->{'item226'}->set_sensitive(1);
    #    $MyUI->FORM->{'item227'}->set_sensitive(1);
    #    $MyUI->FORM->{'item228'}->set_sensitive(1);
    #} else {
    #    $MyUI->FORM->{'item226'}->set_sensitive(0);
    #    $MyUI->FORM->{'item227'}->set_sensitive(0);
    #    $MyUI->FORM->{'item228'}->set_sensitive(0);
    #};
    if($MyUI->FORM->{'seznam_polozek'}->get_selection->get_selected) {
        $MyUI->FORM->{'button_opravit'}->set_sensitive(1);
        $MyUI->FORM->{'button_kopirovat'}->set_sensitive(1);
        $MyUI->FORM->{'button_vyjmout'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'button_opravit'}->set_sensitive(0);
        $MyUI->FORM->{'button_kopirovat'}->set_sensitive(0);
        $MyUI->FORM->{'button_vyjmout'}->set_sensitive(0);
    };
};


sub on_button_opravit_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $model=$MyUI->FORM->{'seznam_polozek'}->get_model;
    my $iter=$MyUI->FORM->{'seznam_polozek'}->get_selection->get_selected;
    my $KartaPolozkyFaktury=new KartaPolozkyFaktury;
    if((my @novepolozky=$KartaPolozkyFaktury->run("cfg"=>[%MyMoney],"polozky"=>[@Polozky],"polozka"=>$model->get($iter,0),"sazbadph1"=>$FakturaVystavena->get('sazbadph1'),"sazbadph2"=>$FakturaVystavena->get('sazbadph2'),"popis"=>$MyUI->FORM->{'popis'}->get_text))) {
        @Polozky=@novepolozky;
        $FakturaVystavena->set('korekcecen',0);
        $MyUI->init;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_kopirovat_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $model=$MyUI->FORM->{'seznam_polozek'}->get_model;
    my $iter=$MyUI->FORM->{'seznam_polozek'}->get_selection->get_selected;
    my $KartaPolozkyFaktury=new KartaPolozkyFaktury;
    if((my @novepolozky=$KartaPolozkyFaktury->run("cfg"=>[%MyMoney],"polozky"=>[@Polozky],"polozka"=>0,"copy"=>$model->get($iter,0),"sazbadph1"=>$FakturaVystavena->get('sazbadph1'),"sazbadph2"=>$FakturaVystavena->get('sazbadph2'),"popis"=>$MyUI->FORM->{'popis'}->get_text))) {
        @Polozky=@novepolozky;
        $FakturaVystavena->set('korekcecen',0);
        $MyUI->init;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_vyjmout_clicked {
    my $model=$MyUI->FORM->{'seznam_polozek'}->get_model;
    my $iter=$MyUI->FORM->{'seznam_polozek'}->get_selection->get_selected;
    my $poradi=1;
    my @pol=();
    my $i=1;
    foreach $_ (@Polozky) {
        if($i ne $model->get($iter,0)) {
            push(@pol,$_);
            $pol[$#pol]->set('poradi',$poradi);
            $poradi++;
        };
        $i++;
    };
    @Polozky=@pol;
    if(!@Polozky) {
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value("z0",0);
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value("z1",0);
        $MyUI->FORM->{'_danova_kalkulacka'}->set_value("z2",0);

        $MyUI->FORM->{'sleva'}->set_value(0);
    };
    $FakturaVystavena->set('korekcecen',0);
    $MyUI->init;
};

sub celkova_cena_changed {
    # je potreba prijit na to proc ten event chodi 2x - poprve s prazdnou hodnotou vcdph3 :(
    if($MyUI->FORM->{'_danova_kalkulacka'}->get_value('vcdph3') ne "") {
        $FakturaVystavena->set('kuhradesdp',$MyUI->FORM->{'_danova_kalkulacka'}->get_value('vcdph3'));
        if($MyUI->FORM->{'dobropis'}->get_active) {
            $FakturaVystavena->set('proplatit',($FakturaVystavena->get('kuhradesdp')-$FakturaVystavena->get('zaplaceno'))*-1);
        } else {
            $FakturaVystavena->set('proplatit',$FakturaVystavena->get('kuhradesdp')-$FakturaVystavena->get('zaplaceno'));
        };
        $MyUI->FORM->{'zbyva_zaplatit'}->set_label(Tools::HumanNums(sprintf("%01.2f",$FakturaVystavena->get('proplatit'))));
    };
};

sub on_sleva_changed {
    if(!$first_init) {
        $FakturaVystavena->set('korekcecen',0);
    };
    $MyUI->init;
};

sub to_numeric {
    my($self,$val)=@_;
    $val=~s/,/\./;
    return($val);
};

sub on_button_zrusenislev_clicked {
    $MyUI->FORM->{'sleva'}->set_value(0);
    my @SazbyDPH=(0,$FakturaVystavena->get('sazbadph1'),$FakturaVystavena->get('sazbadph2'));
    foreach my $polozka (@Polozky) {
        $polozka->set('sleva',0);
        my $zaklad=0;
        my $dph=0;
        my $sazbadph=$SazbyDPH[$polozka->get('sazbadph')];
    
        if($polozka->get('typceny') eq 0) {
            $zaklad=$polozka->get('cenamj');
        };
        if($polozka->get('typceny') eq 1) {
            $zaklad=($zaklad=$polozka->get('cenamj')/(100+$sazbadph))*100;
        };
        if($polozka->get('typceny') eq 2) {
            $zaklad=($zaklad=$polozka->get('cenamj')/$sazbadph)*100;
        };
        if($polozka->get('typceny') eq 3) {
            $zaklad=$zaklad=$polozka->get('cenamj');
        };
        $dph=($zaklad/100)*$sazbadph;
        
        $polozka->set('mjzaklad',$MyUI->to_numeric(sprintf("%01.4f",$zaklad)));
        $polozka->set('mjdph',$MyUI->to_numeric(sprintf("%01.4f",$dph)));
        $polozka->set('mjvcdph',$MyUI->to_numeric(sprintf("%01.4f",$zaklad+$dph)));
    
        $polozka->set('celkemzaklad',$MyUI->to_numeric(sprintf("%01.2f",$zaklad*$polozka->get('pocetmj'))));
        $polozka->set('celkemdph',$MyUI->to_numeric(sprintf("%01.2f",$dph*$polozka->get('pocetmj'))));
        $polozka->set('celkemvcdph',$MyUI->to_numeric(sprintf("%01.2f",($zaklad+$dph)*$polozka->get('pocetmj'))));
    };
    $MyUI->init;
};

sub on_doklad_changed {
    if((!$FakturaVystavena->get('cislo') && (($MyUI->FORM->{'varsymbol'}->get_text eq '') || ($MyUI->FORM->{'varsymbol'}->get_text eq $FakturaVystavena->get('doklad'))))) {
        $MyUI->FORM->{'varsymbol'}->set_text($MyUI->FORM->{'doklad'}->get_text);
    };
    $FakturaVystavena->set('doklad',$MyUI->FORM->{'doklad'}->get_text);
};

sub on_button_vratitciselnouradu_clicked {
    $MyUI->uvolnit_blokovane_cislo_rady;
    $MyUI->FORM->{'doklad'}->set_text('');
    $MyUI->FORM->{'doklad'}->set_sensitive(1);
    $MyUI->FORM->{'button_volnecisla'}->set_sensitive(0);
    $MyUI->FORM->{'button_vratitciselnouradu'}->hide;
    $MyUI->FORM->{'button_ciselnarada'}->show;
    $MyUI->FORM->{'button_ciselnarada'}->set_sensitive(1);
};

sub nastavit_ciselnou_radu {
    my($self,$rada_zkrat)=@_;
    # tohle je potreba rest jako TRANSAKCE s uzamcenim
    $CiselnaRada=new Table('r_CisRady',%MyMoney);
    $CiselnaRada->load("rada='".$rada_zkrat."'");
    my $doklad=$CiselnaRada->get('rada');
    my $cislodokladu_r=0;
    $CiselnaRada->get('cislo');
    my $Databaze=new Databaze(%MyMoney);
    $Databaze->Read("r".$MyMoney{RokData}->get('id')."_VolneCis","rada='".$rada_zkrat."' AND nenab='0' AND in_use='0'",('rada','cislo'));
    my $nejnizsicislo=999999999999;
    my $found=0;
    for(my $i=0;$i<$Databaze->numrows;$i++) {
        my %row=$Databaze->fetchhash;
        if($row{'cislo'}<$nejnizsicislo) {
            $nejnizsicislo=$row{'cislo'};
            $found=1;
        };
    };
    if($found) {
        my $VolneCislo=new Table("r_VolneCis",%MyMoney);
        $VolneCislo->load("cislo='".$nejnizsicislo."' AND rada='".$rada_zkrat."' AND nenab='0' AND in_use='0'");
        $VolneCislo->set('in_use',strftime("%s",localtime));
        $VolneCislo->set('blokovano_uzivatelem',$MyMoney{'Uzivatel'}->get('id'));
        $VolneCislo->set('uzivatel',$MyMoney{'Uzivatel'}->get('jmeno'));
        $VolneCislo->update;
        $cislodokladu_r=$nejnizsicislo;
        @blokovane_cislo=($rada_zkrat,$cislodokladu_r,$VolneCislo->get('in_use'));
    } else {
        my $VolneCislo=new Table("r_VolneCis",%MyMoney);
        $VolneCislo->set('rada',$rada_zkrat);
        $VolneCislo->set('cislo',$CiselnaRada->get('cislo'));
        $VolneCislo->set('radacislo',$rada_zkrat.":".$CiselnaRada->get('cislo'));
        $VolneCislo->set('in_use',strftime("%s",localtime));
        $VolneCislo->set('blokovano_uzivatelem',$MyMoney{'Uzivatel'}->get('id'));
        $VolneCislo->set('uzivatel',$MyMoney{'Uzivatel'}->get('jmeno'));
        $VolneCislo->set('nenab',0);
        $cislodokladu_r=$CiselnaRada->get('cislo');
        $CiselnaRada->set('cislo',$cislodokladu_r+1);
        $VolneCislo->save;
        $CiselnaRada->update;
        @blokovane_cislo=($rada_zkrat,$cislodokladu_r,$VolneCislo->get('in_use'));
    };
    # konec TRANSAKCE

    if($CiselnaRada->get('nuly')) {
        $doklad.=sprintf("%0".$CiselnaRada->get('pocetmist')."s",$cislodokladu_r);
    } else {
        $doklad.=$cislodokladu_r;
    };
    $MyUI->FORM->{'doklad'}->set_text($doklad);
    $FakturaVystavena->set('doklad',$doklad);
    $FakturaVystavena->set('cisrada',$rada_zkrat);
    $FakturaVystavena->set('cisradacislo',$cislodokladu_r);
    $MyUI->FORM->{'doklad'}->set_sensitive(0);
    $MyUI->FORM->{'button_volnecisla'}->set_sensitive(1);
    $MyUI->FORM->{'button_vratitciselnouradu'}->show;
    $MyUI->FORM->{'button_ciselnarada'}->hide;
};

sub on_button_ciselnarada_clicked {
   $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('ciselne_rady',"cfg"=>[%MyMoney],"ok_butt"=>1,"where"=>"vf='1'","selected_rows_by"=>"rada",selected_rows=>[$MyMoney{'MainCfg'}->get('VF_last_rada')])) {
        my $tbl=new Table('r_CisRady',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->nastavit_ciselnou_radu($tbl->get('rada'));
                $MyMoney{'MainCfg'}->set('VF_last_rada',$tbl->get('rada'))
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->on_button_vratitciselnouradu_clicked;
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub pouzit_volne_cislo {
    my($self,$rada_zkrat,$cislo)=@_;

    # tohle je potreba rest jako TRANSAKCE s uzamcenim
    $CiselnaRada=new Table('r_CisRady',%MyMoney);
    $CiselnaRada->load("rada='".$rada_zkrat."'");
    my $doklad=$CiselnaRada->get('rada');
    my $cislodokladu_r=0;
    my $VolneCislo=new Table("r_VolneCis",%MyMoney);
    if(!$VolneCislo->load("cislo='".$cislo."' AND rada='".$rada_zkrat."' AND nenab='0' AND in_use='0'",1)) {
        #konec TRANSAKCE
        my $Dialog=new Dialog;
        $Dialog->show("text"=>"Zvolene volne cislo z teto rady nelze nacist!\nZrejme je blokovano, nebo bylo pouzito jinym uzivatelem.","type"=>"error");
        return;
    };
    $VolneCislo->set('in_use',strftime("%s",localtime));
    $VolneCislo->set('blokovano_uzivatelem',$MyMoney{'Uzivatel'}->get('id'));
    $VolneCislo->set('uzivatel',$MyMoney{'Uzivatel'}->get('jmeno'));
    $VolneCislo->update;
    $cislodokladu_r=$cislo;

    # uvolnime stare cislo
    my $VolneCisloB=new Table('r_VolneCis',%MyMoney);
    $VolneCisloB->load("rada='".$blokovane_cislo[0]."' AND cislo='".$blokovane_cislo[1]."' AND in_use='".$blokovane_cislo[2]."'");
    $VolneCisloB->set('in_use',0);
    $VolneCisloB->set('blokovano_uzivatelem',0);
    $VolneCisloB->set('uzivatel','');
    $VolneCisloB->update;
    @blokovane_cislo=();

    @blokovane_cislo=($rada_zkrat,$cislodokladu_r,$VolneCislo->get('in_use'));
    # konec TRANSAKCE

    if($CiselnaRada->get('nuly')) {
        $doklad.=sprintf("%0".$CiselnaRada->get('pocetmist')."s",$cislodokladu_r);
    } else {
        $doklad.=$cislodokladu_r;
    };
    $MyUI->FORM->{'doklad'}->set_text($doklad);
    $FakturaVystavena->set('doklad',$doklad);
    $FakturaVystavena->set('cisradacislo',$cislodokladu_r);

    $MyUI->FORM->{'doklad'}->set_sensitive(0);
    $MyUI->FORM->{'button_volnecisla'}->set_sensitive(1);
    $MyUI->FORM->{'button_vratitciselnouradu'}->show;
    $MyUI->FORM->{'button_ciselnarada'}->hide;
};

sub on_button_volnecisla_clicked {
   $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('volna_cisla',"cfg"=>[%MyMoney],"ok_butt"=>1,"empty_butt"=>0,"where"=>"rada='".$blokovane_cislo[0]."' AND cislo!='".$blokovane_cislo[1]."'")) {
        my $tbl=new Table('r_VolneCis',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->pouzit_volne_cislo($tbl->get('rada'),$tbl->get('cislo'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};


sub polozka_nova {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $KartaPolozkyFaktury=new KartaPolozkyFaktury;
    if((my @novepolozky=$KartaPolozkyFaktury->run("cfg"=>[%MyMoney],"polozky"=>[@Polozky],"polozka"=>0,"sazbadph1"=>$FakturaVystavena->get('sazbadph1'),"sazbadph2"=>$FakturaVystavena->get('sazbadph2'),"popis"=>$MyUI->FORM->{'popis'}->get_text))) {
        @Polozky=@novepolozky;
        $FakturaVystavena->set('korekcecen',0);
        $MyUI->init;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_pridat_clicked {
    my $button=shift;
#    my $MenuVFPridatPolozku=new MenuVFPridatPolozku;
    $MyUI->FORM->{'MenuVFPridatPolozku'}->popup(undef, # parent menu shell
                 undef, # parent menu item
                 undef, # menu pos func
                 undef, # data
                 $button,
                 0);
};



sub create_menu_pridat {

    my %widgets=();
    
    $MyUI->FORM->{'MenuVFPridatPolozku'} = new Gtk2::Menu;

    $MyUI->FORM->{'MenuVFPridatPolozku'}{'accelgroup'} = new Gtk2::AccelGroup;
    $MyUI->FORM->{'FakturaVystavena'}->add_accel_group($MyUI->FORM->{'MenuVFPridatPolozku'}{'accelgroup'});
    #$MyUI->FORM->{'MenuVFPridatPolozku'}{'accelgroup'}->attach($MyUI->FORM->{'MenuVFPridatPolozku'});
	#
	# Construct a GtkMenuItem 'item250'
	$widgets{'item250'} = new_with_mnemonic Gtk2::MenuItem(_('nová'));
	$MyUI->FORM->{'MenuVFPridatPolozku'}->append($widgets{'item250'});
	$widgets{'item250'}->show;
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item250'} = $widgets{'item250'};
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item250'}->add_accelerator('activate', $MyUI->FORM->{'MenuVFPridatPolozku'}{'accelgroup'}, Gtk2::Gdk->keyval_from_name('W') || 87 , ['control_mask'], ['visible', 'locked']);
	# End of GtkMenuItem 'item250'
	#
	#
	# Construct a GtkMenuItem 'item251'
	$widgets{'item251'} = new_with_mnemonic Gtk2::MenuItem(_('odpočet zálohy'));
	$MyUI->FORM->{'MenuVFPridatPolozku'}->append($widgets{'item251'});
	$widgets{'item251'}->show;
        $widgets{'item251'}->set_sensitive(0);
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item251'} = $widgets{'item251'};
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item251'}->add_accelerator('activate', $MyUI->FORM->{'MenuVFPridatPolozku'}{'accelgroup'}, Gtk2::Gdk->keyval_from_name('P') || 80 , ['control_mask'], ['visible', 'locked']);
	# End of GtkMenuItem 'item251'
	#
	#
	# Construct a GtkMenuItem 'item252'
	$widgets{'item252'} = new_with_mnemonic Gtk2::MenuItem(_('ze skladu'));
	$MyUI->FORM->{'MenuVFPridatPolozku'}->append($widgets{'item252'});
	$widgets{'item252'}->show;
	$widgets{'item252'}->set_sensitive(0);
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item252'} = $widgets{'item252'};
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item252'}->add_accelerator('activate', $MyUI->FORM->{'MenuVFPridatPolozku'}{'accelgroup'}, Gtk2::Gdk->keyval_from_name('S') || 83 , ['control_mask'], ['visible', 'locked']);
	# End of GtkMenuItem 'item252'
	#
	#
	# Construct a GtkMenuItem 'item253'
	$widgets{'item253'} = new_with_mnemonic Gtk2::MenuItem(_('z poptávky'));
	$MyUI->FORM->{'MenuVFPridatPolozku'}->append($widgets{'item253'});
	$widgets{'item253'}->show;
	$widgets{'item253'}->set_sensitive(0);
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item253'} = $widgets{'item253'};
	# End of GtkMenuItem 'item253'
	#
	#
	# Construct a GtkMenuItem 'item254'
	$widgets{'item254'} = new_with_mnemonic Gtk2::MenuItem(_('z nabídky'));
	$MyUI->FORM->{'MenuVFPridatPolozku'}->append($widgets{'item254'});
	$widgets{'item254'}->show;
	$widgets{'item254'}->set_sensitive(0);
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item254'} = $widgets{'item254'};
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item254'}->add_accelerator('activate', $MyUI->FORM->{'MenuVFPridatPolozku'}{'accelgroup'}, Gtk2::Gdk->keyval_from_name('B') || 66 , ['control_mask'], ['visible', 'locked']);
	# End of GtkMenuItem 'item254'
	#
	#
	# Construct a GtkMenuItem 'item255'
	$widgets{'item255'} = new_with_mnemonic Gtk2::MenuItem(_('z objednávky'));
	$MyUI->FORM->{'MenuVFPridatPolozku'}->append($widgets{'item255'});
	$widgets{'item255'}->show;
	$widgets{'item255'}->set_sensitive(0);
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item255'} = $widgets{'item255'};
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item255'}->add_accelerator('activate', $MyUI->FORM->{'MenuVFPridatPolozku'}{'accelgroup'}, Gtk2::Gdk->keyval_from_name('O') || 79 , ['control_mask'], ['visible', 'locked']);
	# End of GtkMenuItem 'item255'
	#
	#
	# Construct a GtkMenuItem 'item256'
	$widgets{'item256'} = new_with_mnemonic Gtk2::MenuItem(_('z dodacího listu'));
	$MyUI->FORM->{'MenuVFPridatPolozku'}->append($widgets{'item256'});
	$widgets{'item256'}->show;
	$widgets{'item256'}->set_sensitive(0);
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item256'} = $widgets{'item256'};
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item256'}->add_accelerator('activate', $MyUI->FORM->{'MenuVFPridatPolozku'}{'accelgroup'}, Gtk2::Gdk->keyval_from_name('H') || 72 , ['control_mask'], ['visible', 'locked']);
	# End of GtkMenuItem 'item256'
	#
	#
	# Construct a GtkMenuItem 'item257'
	$widgets{'item257'} = new_with_mnemonic Gtk2::MenuItem(_('z rezervací'));
	$MyUI->FORM->{'MenuVFPridatPolozku'}->append($widgets{'item257'});
	$widgets{'item257'}->show;
	$widgets{'item257'}->set_sensitive(0);
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item257'} = $widgets{'item257'};
	$MyUI->FORM->{'MenuVFPridatPolozku'}{'item257'}->add_accelerator('activate', $MyUI->FORM->{'MenuVFPridatPolozku'}{'accelgroup'}, Gtk2::Gdk->keyval_from_name('R') || 82 , ['control_mask'], ['visible', 'locked']);
	# End of GtkMenuItem 'item257'
	#
    #
    # Connect all signals now that widgets are constructed
    $MyUI->FORM->{'MenuVFPridatPolozku'}{'item250'}->signal_connect('activate', "polozka_nova");
    $MyUI->FORM->{'MenuVFPridatPolozku'}{'item251'}->signal_connect('activate', "polozka_odpocet_zalohy");
    $MyUI->FORM->{'MenuVFPridatPolozku'}{'item252'}->signal_connect('activate', "polozka_ze_skladu");
    $MyUI->FORM->{'MenuVFPridatPolozku'}{'item253'}->signal_connect('activate', "polozka_z_poptavky");
    $MyUI->FORM->{'MenuVFPridatPolozku'}{'item254'}->signal_connect('activate', "polozka_z_nabidky");
    $MyUI->FORM->{'MenuVFPridatPolozku'}{'item255'}->signal_connect('activate', "polozka_z_objednavky");
    $MyUI->FORM->{'MenuVFPridatPolozku'}{'item256'}->signal_connect('activate', "polozka_z_dodaciho_listu");
    $MyUI->FORM->{'MenuVFPridatPolozku'}{'item257'}->signal_connect('activate', "polozka_z_rezervaci");
    # End of GtkMenu 'MenuVFPridatPolozku'
};

sub adresy_odberatele {
    #
    if($FakturaVystavena->get('odberatel')) {
        $MyUI->FORM->{'button_odberatel'}->hide;
        $MyUI->FORM->{'button_odberatel_zrusit'}->show;
        $MyUI->FORM->{'o_nazev'}->set_sensitive(0);
        $MyUI->FORM->{'o_jmeno'}->set_sensitive(0);
        $MyUI->FORM->{'o_ulice'}->set_sensitive(0);
        $MyUI->FORM->{'o_psc'}->set_sensitive(0);
        $MyUI->FORM->{'o_mesto'}->set_sensitive(0);
        $MyUI->FORM->{'o_stat'}->set_sensitive(0);
    } else {
        $MyUI->FORM->{'button_odberatel_zrusit'}->hide;
        $MyUI->FORM->{'button_odberatel'}->show;
        $MyUI->FORM->{'o_nazev'}->set_sensitive(1);
        $MyUI->FORM->{'o_jmeno'}->set_sensitive(1);
        $MyUI->FORM->{'o_ulice'}->set_sensitive(1);
        $MyUI->FORM->{'o_psc'}->set_sensitive(1);
        $MyUI->FORM->{'o_mesto'}->set_sensitive(1);
        $MyUI->FORM->{'o_stat'}->set_sensitive(1);
    };
    if($FakturaVystavena->get('odberatelf')) {
        $MyUI->FORM->{'button_fakadresa'}->hide;
        $MyUI->FORM->{'button_fakadresa_zrusit'}->show;
        $MyUI->FORM->{'of_nazev'}->set_sensitive(0);
        $MyUI->FORM->{'of_jmeno'}->set_sensitive(0);
        $MyUI->FORM->{'of_ulice'}->set_sensitive(0);
        $MyUI->FORM->{'of_psc'}->set_sensitive(0);
        $MyUI->FORM->{'of_mesto'}->set_sensitive(0);
        $MyUI->FORM->{'of_stat'}->set_sensitive(0);
    } else {
        $MyUI->FORM->{'button_fakadresa_zrusit'}->hide;
        $MyUI->FORM->{'button_fakadresa'}->show;
        $MyUI->FORM->{'of_nazev'}->set_sensitive(1);
        $MyUI->FORM->{'of_jmeno'}->set_sensitive(1);
        $MyUI->FORM->{'of_ulice'}->set_sensitive(1);
        $MyUI->FORM->{'of_psc'}->set_sensitive(1);
        $MyUI->FORM->{'of_mesto'}->set_sensitive(1);
        $MyUI->FORM->{'of_stat'}->set_sensitive(1);
    };
    if($FakturaVystavena->get('konecprij')) {
        $MyUI->FORM->{'button_koncprijemce'}->hide;
        $MyUI->FORM->{'button_koncprijemce_zrusit'}->show;
        $MyUI->FORM->{'k_nazev'}->set_sensitive(0);
        $MyUI->FORM->{'k_jmeno'}->set_sensitive(0);
        $MyUI->FORM->{'k_ulice'}->set_sensitive(0);
        $MyUI->FORM->{'k_psc'}->set_sensitive(0);
        $MyUI->FORM->{'k_mesto'}->set_sensitive(0);
        $MyUI->FORM->{'k_stat'}->set_sensitive(0);
    } else {
        $MyUI->FORM->{'button_koncprijemce_zrusit'}->hide;
        $MyUI->FORM->{'button_koncprijemce'}->show;
        $MyUI->FORM->{'k_nazev'}->set_sensitive(1);
        $MyUI->FORM->{'k_jmeno'}->set_sensitive(1);
        $MyUI->FORM->{'k_ulice'}->set_sensitive(1);
        $MyUI->FORM->{'k_psc'}->set_sensitive(1);
        $MyUI->FORM->{'k_mesto'}->set_sensitive(1);
        $MyUI->FORM->{'k_stat'}->set_sensitive(1);
    };
};

sub on_oadresa_changed {
    if($dissable_changes) {
        return;
    };
    if((($FakturaVystavena->get('odberatel') eq '0') &&
       ($FakturaVystavena->get('odberatel') eq $FakturaVystavena->get('konecprij')) &&
       ($FakturaVystavena->get('o_nazev') eq $FakturaVystavena->get('k_nazev')) &&
       ($FakturaVystavena->get('o_jmeno') eq $FakturaVystavena->get('k_jmeno')) &&
       ($FakturaVystavena->get('o_ulice') eq $FakturaVystavena->get('k_ulice')) &&
       ($FakturaVystavena->get('o_psc') eq $FakturaVystavena->get('k_psc')) &&
       ($FakturaVystavena->get('o_mesto') eq $FakturaVystavena->get('k_mesto')) &&
       ($FakturaVystavena->get('o_stat') eq $FakturaVystavena->get('k_stat'))) ||
       (($FakturaVystavena->get('odberatel') ne '0') &&
        ($FakturaVystavena->get('odberatel') eq $FakturaVystavena->get('konecprij')))) {
        
        $MyUI->FORM->{'k_nazev'}->set_text($MyUI->FORM->{'o_nazev'}->get_text);
        $MyUI->FORM->{'k_jmeno'}->set_text($MyUI->FORM->{'o_jmeno'}->get_text);
        $MyUI->FORM->{'k_ulice'}->set_text($MyUI->FORM->{'o_ulice'}->get_text);
        $MyUI->FORM->{'k_psc'}->set_text($MyUI->FORM->{'o_psc'}->get_text);
        $MyUI->FORM->{'k_mesto'}->set_text($MyUI->FORM->{'o_mesto'}->get_text);
        $MyUI->FORM->{'k_stat'}->set_text($MyUI->FORM->{'o_stat'}->get_text);
    };
    if((($FakturaVystavena->get('odberatelf') eq '0') &&
       ($FakturaVystavena->get('odberatelf') eq $FakturaVystavena->get('odberatel')) &&
       ($FakturaVystavena->get('of_nazev') eq $FakturaVystavena->get('o_nazev')) &&
       ($FakturaVystavena->get('of_jmeno') eq $FakturaVystavena->get('o_jmeno')) &&
       ($FakturaVystavena->get('of_ulice') eq $FakturaVystavena->get('o_ulice')) &&
       ($FakturaVystavena->get('of_psc') eq $FakturaVystavena->get('o_psc')) &&
       ($FakturaVystavena->get('of_mesto') eq $FakturaVystavena->get('o_mesto')) &&
       ($FakturaVystavena->get('of_stat') eq $FakturaVystavena->get('o_stat'))) ||
       (($FakturaVystavena->get('odberatelf') ne '0') &&
        ($FakturaVystavena->get('odberatelf') eq $FakturaVystavena->get('odberatel')))) {
        
        $MyUI->FORM->{'of_nazev'}->set_text($MyUI->FORM->{'o_nazev'}->get_text);
        $MyUI->FORM->{'of_jmeno'}->set_text($MyUI->FORM->{'o_jmeno'}->get_text);
        $MyUI->FORM->{'of_ulice'}->set_text($MyUI->FORM->{'o_ulice'}->get_text);
        $MyUI->FORM->{'of_psc'}->set_text($MyUI->FORM->{'o_psc'}->get_text);
        $MyUI->FORM->{'of_mesto'}->set_text($MyUI->FORM->{'o_mesto'}->get_text);
        $MyUI->FORM->{'of_stat'}->set_text($MyUI->FORM->{'o_stat'}->get_text);
    };

    $FakturaVystavena->set('o_nazev',$MyUI->FORM->{'o_nazev'}->get_text);
    $FakturaVystavena->set('o_jmeno',$MyUI->FORM->{'o_jmeno'}->get_text);
    $FakturaVystavena->set('o_ulice',$MyUI->FORM->{'o_ulice'}->get_text);
    $FakturaVystavena->set('o_psc',$MyUI->FORM->{'o_psc'}->get_text);
    $FakturaVystavena->set('o_mesto',$MyUI->FORM->{'o_mesto'}->get_text);
    $FakturaVystavena->set('o_stat',$MyUI->FORM->{'o_stat'}->get_text);
};

sub on_kadresa_changed {
    if($dissable_changes) {
        return;
    };
    if((($FakturaVystavena->get('odberatelf') eq '0') &&
       ($FakturaVystavena->get('odberatelf') eq $FakturaVystavena->get('konecprij')) &&
       ($FakturaVystavena->get('of_nazev') eq $FakturaVystavena->get('k_nazev')) &&
       ($FakturaVystavena->get('of_jmeno') eq $FakturaVystavena->get('k_jmeno')) &&
       ($FakturaVystavena->get('of_ulice') eq $FakturaVystavena->get('k_ulice')) &&
       ($FakturaVystavena->get('of_psc') eq $FakturaVystavena->get('k_psc')) &&
       ($FakturaVystavena->get('of_mesto') eq $FakturaVystavena->get('k_mesto')) &&
       ($FakturaVystavena->get('of_stat') eq $FakturaVystavena->get('k_stat'))) ||
       (($FakturaVystavena->get('odberatelf') ne '0') &&
        ($FakturaVystavena->get('odberatelf') eq $FakturaVystavena->get('konecprij')))) {
        
        $MyUI->FORM->{'of_nazev'}->set_text($MyUI->FORM->{'k_nazev'}->get_text);
        $MyUI->FORM->{'of_jmeno'}->set_text($MyUI->FORM->{'k_jmeno'}->get_text);
        $MyUI->FORM->{'of_ulice'}->set_text($MyUI->FORM->{'k_ulice'}->get_text);
        $MyUI->FORM->{'of_psc'}->set_text($MyUI->FORM->{'k_psc'}->get_text);
        $MyUI->FORM->{'of_mesto'}->set_text($MyUI->FORM->{'k_mesto'}->get_text);
        $MyUI->FORM->{'of_stat'}->set_text($MyUI->FORM->{'k_stat'}->get_text);
    };
    $FakturaVystavena->set('k_nazev',$MyUI->FORM->{'k_nazev'}->get_text);
    $FakturaVystavena->set('k_jmeno',$MyUI->FORM->{'k_jmeno'}->get_text);
    $FakturaVystavena->set('k_ulice',$MyUI->FORM->{'k_ulice'}->get_text);
    $FakturaVystavena->set('k_psc',$MyUI->FORM->{'k_psc'}->get_text);
    $FakturaVystavena->set('k_mesto',$MyUI->FORM->{'k_mesto'}->get_text);
    $FakturaVystavena->set('k_stat',$MyUI->FORM->{'k_stat'}->get_text);
};

sub on_fadresa_changed {
    if($dissable_changes) {
        return;
    };
    $FakturaVystavena->set('of_nazev',$MyUI->FORM->{'of_nazev'}->get_text);
    $FakturaVystavena->set('of_jmeno',$MyUI->FORM->{'of_jmeno'}->get_text);
    $FakturaVystavena->set('of_ulice',$MyUI->FORM->{'of_ulice'}->get_text);
    $FakturaVystavena->set('of_psc',$MyUI->FORM->{'of_psc'}->get_text);
    $FakturaVystavena->set('of_mesto',$MyUI->FORM->{'of_mesto'}->get_text);
    $FakturaVystavena->set('of_stat',$MyUI->FORM->{'of_stat'}->get_text);
};

sub on_button_odberatel_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Adresar=new Adresar;
    my @firmy;
    if((@firmy=$Adresar->run('cfg'=>{%MyMoney},'selection_mode'=>'single','selected_firmy'=>[$FakturaVystavena->get('odberatel')]))) {
        my $Adresa=new Table('a_AdresarF',%MyMoney);
        #my $Jednatel=new Table('a_AdresarF',%MyMoney);
        if($firmy[0]!=0) {
            $Adresa->load("id='".$firmy[0]."'");
        };
        $MyUI->FORM->{'o_nazev'}->set_text($Adresa->get('ob_nazev'));
        $MyUI->FORM->{'o_ulice'}->set_text($Adresa->get('ob_ulice'));
        $MyUI->FORM->{'o_psc'}->set_text($Adresa->get('ob_psc'));
        $MyUI->FORM->{'o_mesto'}->set_text($Adresa->get('ob_mesto'));
        $MyUI->FORM->{'o_stat'}->set_text($Adresa->get('ob_statnazev'));
        $MyUI->FORM->{'o_jmeno'}->set_text("");
        $MyUI->FORM->{'o_ico'}->set_text($Adresa->get('ico'));
        $MyUI->FORM->{'o_dic'}->set_text($Adresa->get('dic'));
        if($FakturaVystavena->get('odberatel') eq $FakturaVystavena->get('konecprij')) {
            $MyUI->FORM->{'k_nazev'}->set_text($Adresa->get('pr_nazev'));
            $MyUI->FORM->{'k_ulice'}->set_text($Adresa->get('pr_ulice'));
            $MyUI->FORM->{'k_psc'}->set_text($Adresa->get('pr_psc'));
            $MyUI->FORM->{'k_mesto'}->set_text($Adresa->get('pr_mesto'));
            $MyUI->FORM->{'k_stat'}->set_text($Adresa->get('pr_statnazev'));
            $MyUI->FORM->{'k_jmeno'}->set_text("");
            $FakturaVystavena->set('konecprij',$Adresa->get('id'));
        };
        if($FakturaVystavena->get('odberatel') eq $FakturaVystavena->get('odberatelf')) {
            $MyUI->FORM->{'of_nazev'}->set_text($Adresa->get('fa_nazev'));
            $MyUI->FORM->{'of_ulice'}->set_text($Adresa->get('fa_ulice'));
            $MyUI->FORM->{'of_psc'}->set_text($Adresa->get('fa_psc'));
            $MyUI->FORM->{'of_mesto'}->set_text($Adresa->get('fa_mesto'));
            $MyUI->FORM->{'of_stat'}->set_text($Adresa->get('fa_statnazev'));
            $MyUI->FORM->{'of_jmeno'}->set_text("");
            $FakturaVystavena->set('odberatelf',$Adresa->get('id'));
        };
        $FakturaVystavena->set('odberatel',$Adresa->get('id'));
        $MyUI->adresy_odberatele;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_koncprijemce_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Adresar=new Adresar;
    my @firmy;
    if((@firmy=$Adresar->run('cfg'=>{%MyMoney},'selection_mode'=>'single','selected_firmy'=>[$FakturaVystavena->get('konecprij')]))) {
        my $Adresa=new Table('a_AdresarF',%MyMoney);
        #my $Jednatel=new Table('a_AdresarF',%MyMoney);
        if($firmy[0]!=0) {
            $Adresa->load("id='".$firmy[0]."'");
        };
        $FakturaVystavena->set('konecprij',$Adresa->get('id'));
        $MyUI->FORM->{'k_nazev'}->set_text($Adresa->get('pr_nazev'));
        $MyUI->FORM->{'k_ulice'}->set_text($Adresa->get('pr_ulice'));
        $MyUI->FORM->{'k_psc'}->set_text($Adresa->get('pr_psc'));
        $MyUI->FORM->{'k_mesto'}->set_text($Adresa->get('pr_mesto'));
        $MyUI->FORM->{'k_stat'}->set_text($Adresa->get('pr_statnazev'));
        $MyUI->FORM->{'k_jmeno'}->set_text("");
        $MyUI->adresy_odberatele;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_fakadresa_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Adresar=new Adresar;
    my @firmy;
    if((@firmy=$Adresar->run('cfg'=>{%MyMoney},'selection_mode'=>'single','selected_firmy'=>[$FakturaVystavena->get('odberatelf')]))) {
        my $Adresa=new Table('a_AdresarF',%MyMoney);
        #my $Jednatel=new Table('a_AdresarF',%MyMoney);
        if($firmy[0]!=0) {
            $Adresa->load("id='".$firmy[0]."'");
        };
        $FakturaVystavena->set('odberatelf',$Adresa->get('id'));
        $MyUI->FORM->{'of_nazev'}->set_text($Adresa->get('fa_nazev'));
        $MyUI->FORM->{'of_ulice'}->set_text($Adresa->get('fa_ulice'));
        $MyUI->FORM->{'of_psc'}->set_text($Adresa->get('fa_psc'));
        $MyUI->FORM->{'of_mesto'}->set_text($Adresa->get('fa_mesto'));
        $MyUI->FORM->{'of_stat'}->set_text($Adresa->get('fa_statnazev'));
        $MyUI->FORM->{'of_jmeno'}->set_text("");
        $MyUI->adresy_odberatele;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_odberatel_zrusit_clicked {
    if($FakturaVystavena->get('odberatel') eq $FakturaVystavena->get('konecprij')) {
        $FakturaVystavena->set('konecprij',0);
    };
    if($FakturaVystavena->get('odberatel') eq $FakturaVystavena->get('odberatelf')) {
        $FakturaVystavena->set('odberatelf',0);
    };
    $FakturaVystavena->set('odberatel',0);
    $MyUI->adresy_odberatele;
};

sub on_button_koncprijemce_zrusit_clicked {
    $FakturaVystavena->set('konecprij',0);
    $MyUI->adresy_odberatele;
};

sub on_button_fakadresa_zrusit_clicked {
    $FakturaVystavena->set('odberatelf',0);
    $MyUI->adresy_odberatele;
};

1;
