#!/usr/bin/perl -w

package TextyFaktury;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
use open ':utf8', ':std';

use Gtk2;
init Gtk2;

use lib "./";
use lib::FileChooserDialog;
use lib::Dialog;

my $MyUI;
my %MyMoney;
my @TextyFaktury=();

sub run {
    my ($class, $textpredfa, $textzafa, $textpreddl, $textzadl, %params) = @_;
    %MyMoney=%params;
    my $window=$class;
    $MyUI=$class;
    $MyUI->{'TOPFORM'}=$MyUI->FORM->{'hbox484'};

    $MyUI->FORM->{'textpredfa'}->get_buffer->set_text($textpredfa);
    $MyUI->FORM->{'textzafa'}->get_buffer->set_text($textzafa);
    $MyUI->FORM->{'textpreddl'}->get_buffer->set_text($textpreddl);
    $MyUI->FORM->{'textzadl'}->get_buffer->set_text($textzadl);
    if($textpredfa eq $textpreddl) {
        $MyUI->FORM->{'checkbutton15'}->set_active(1);
    } else {
        $MyUI->FORM->{'checkbutton15'}->set_active(0);
    };
    if($textzafa eq $textzadl) {
        $MyUI->FORM->{'checkbutton16'}->set_active(1);
    } else {
        $MyUI->FORM->{'checkbutton16'}->set_active(0);
    };
    $window->TOPLEVEL->set_title('Texty faktury');
    $MyMoney{'MainCfg'}->window_open("TextyFaktury",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    if(("@TextyFaktury")) {
        return(@TextyFaktury);
    };
    return();
};

sub on_button_close_clicked {
    $MyMoney{'MainCfg'}->window_close("TextyFaktury",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_TextyFaktury_unrealize {
    $MyMoney{'MainCfg'}->window_close("TextyFaktury",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {   
    $MyMoney{'MainCfg'}->window_close("TextyFaktury",$MyUI->TOPLEVEL);
    push(@TextyFaktury,$MyUI->FORM->{'textpredfa'}->get_buffer->get_text($MyUI->FORM->{'textpredfa'}->get_buffer->get_start_iter,$MyUI->FORM->{'textpredfa'}->get_buffer->get_end_iter,1));
    push(@TextyFaktury,$MyUI->FORM->{'textzafa'}->get_buffer->get_text($MyUI->FORM->{'textzafa'}->get_buffer->get_start_iter,$MyUI->FORM->{'textzafa'}->get_buffer->get_end_iter,1));
    push(@TextyFaktury,$MyUI->FORM->{'textpreddl'}->get_buffer->get_text($MyUI->FORM->{'textpreddl'}->get_buffer->get_start_iter,$MyUI->FORM->{'textpreddl'}->get_buffer->get_end_iter,1));
    push(@TextyFaktury,$MyUI->FORM->{'textzadl'}->get_buffer->get_text($MyUI->FORM->{'textzadl'}->get_buffer->get_start_iter,$MyUI->FORM->{'textzadl'}->get_buffer->get_end_iter,1));
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub textpredfa_changed {
    if($MyUI->FORM->{'checkbutton15'}->get_active) {
        $MyUI->FORM->{'textpreddl'}->get_buffer->set_text($MyUI->FORM->{'textpredfa'}->get_buffer->get_text($MyUI->FORM->{'textpredfa'}->get_buffer->get_start_iter,$MyUI->FORM->{'textpredfa'}->get_buffer->get_end_iter,1));
    };
};

sub textzafa_changed {
    if($MyUI->FORM->{'checkbutton16'}->get_active) {
        $MyUI->FORM->{'textzadl'}->get_buffer->set_text($MyUI->FORM->{'textzafa'}->get_buffer->get_text($MyUI->FORM->{'textzafa'}->get_buffer->get_start_iter,$MyUI->FORM->{'textzafa'}->get_buffer->get_end_iter,1));
    };
};


sub open_file {
    my ($self,$textview)=@_;
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $FileChooserDialog=new FileChooserDialog;
    if((my $filename=$FileChooserDialog->run("cfg"=>[%MyMoney],"filter"=>["text/plain"],"action"=>"open"))) {
        if(open(FILE,$filename)) {
            my $txt="";
            while(<FILE>) {
                $txt.=$_;
            };
            close(FILE);
            $MyUI->FORM->{$textview}->get_buffer->set_text($txt);
        } else {
            my $Dialog=new Dialog;
            $Dialog->show('text'=>"Soubor '".$filename."' nelze otevřít pro čtení!",'type'=>'error');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub save_file {
    my ($self,$textview)=@_;
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $FileChooserDialog=new FileChooserDialog;
    if((my $filename=$FileChooserDialog->run("cfg"=>[%MyMoney],"filter"=>["text/plain"],"action"=>"save"))) {
        if(open(FILE,">".$filename)) {
            my $txt=$MyUI->FORM->{$textview}->get_buffer->get_text($MyUI->FORM->{$textview}->get_buffer->get_start_iter,$MyUI->FORM->{$textview}->get_buffer->get_end_iter,1);
            print(FILE "$txt");
            close(FILE);
        } else {
            my $Dialog=new Dialog;
            $Dialog->show('text'=>"Soubor '".$filename."' nelze otevřít pro zápis!",'type'=>'error');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_textpredfa_open_clicked {
    $MyUI->open_file('textpredfa');
    $MyUI->textpredfa_changed;
};

sub on_button_textpredfa_save_clicked {
    $MyUI->save_file('textpredfa');
};

sub on_button_textpredfa_clear_clicked {
    $MyUI->FORM->{'textpredfa'}->get_buffer->set_text('');
    $MyUI->textpredfa_changed;
};

sub on_button_textzafa_open_clicked {
    $MyUI->open_file('textzafa');
    $MyUI->textzafa_changed;
};

sub on_button_textzafa_save_clicked {
    $MyUI->save_file('textzafa');
};

sub on_button_textzafa_clear_clicked {
    $MyUI->FORM->{'textzafa'}->get_buffer->set_text('');
    $MyUI->textzafa_changed;
};

sub on_button_textpreddl_open_clicked {
    $MyUI->open_file('textpreddl');
    $MyUI->FORM->{'checkbutton15'}->set_active(0);
};

sub on_button_textpreddl_save_clicked {
    $MyUI->save_file('textpreddl');
};

sub on_button_textpreddl_clear_clicked {
    $MyUI->FORM->{'textpreddl'}->get_buffer->set_text('');
    $MyUI->FORM->{'checkbutton15'}->set_active(0);
};

sub on_button_textzadl_open_clicked {
    $MyUI->open_file('textzadl');
    $MyUI->FORM->{'checkbutton16'}->set_active(0);
};

sub on_button_textzadl_save_clicked {
    $MyUI->save_file('textzadl');
};

sub on_button_textzadl_clear_clicked {
    $MyUI->FORM->{'textzadl'}->get_buffer->set_text('');
    $MyUI->FORM->{'checkbutton16'}->set_active(0);
};

1;
