#!/usr/bin/perl -w

package UcetPokladna;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;

use lib "./";
use lib::Dialog;
use lib::Locks;
use lib::Databaze;

my $MyUI;
my %MyMoney;
my $retcode="";
my $UcPokl;
my $Locks;

sub upravit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    my $dissable_ok=0;
    $Locks=0;
    if($where) {
        $Locks=new Locks(%MyMoney);
        if(!$Locks->create_lock('r_SzUcPokl',$where)) {
            $dissable_ok=1;
        };
    };
    return($self->run($dissable_ok, $where,0,%params));
};

sub kopirovat {
    my ($self, $where, %params) = @_;
    $Locks=0;
    %MyMoney=%params;
    return($self->run(0, $where,1,%params));
};

sub pridat {
    my ($self, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    return($self->run(0,'',0,%params));
};

sub odstranit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('r_SzUcPokl',$where,1)) {
        return(0);
    };
    my $Databaze=new Databaze(%MyMoney);
    if(!$Databaze->Remove("r".$MyMoney{'RokData'}->get('id')."_SzUcPokl",$where)) {
        $Locks->remove_lock;
        return(0);
    };
    $Locks->remove_lock;
    return(1);
};

sub run {
    my ($class, $dissable_ok, $where, $kopie, %params) = @_;
    $retcode=0;
    %MyMoney=%params;
    my $window=$class;
    $MyUI=$class;
    $UcPokl=new Table('r_SzUcPokl',%MyMoney);
    if(!$kopie) {
        $class->{'where'}=$where;
    } else {
        $class->{'where'}="";
    };
    if($dissable_ok) {
        $window->FORM->{'button_ok'}->set_sensitive(0);
    };

    if($where) {
        if(!$UcPokl->load($where,1)) {
            my $Dialog=new Dialog;
            $Dialog->show("text"=>"Záznam nelze načíst!\nZřejme byl změněn jiným uživatelem.","type"=>"error");
            if($Locks) {
                $Locks->remove_lock;
            };
            return(0);
        };
    };
    $UcPokl->WriteToUI($window->FORM);
    
    $window->on_ucpokl_toggled;
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq "P") {
        $window->FORM->{'hbox245'}->show;
        $window->FORM->{'hseparator67'}->show;
    } else {
        $window->FORM->{'hbox245'}->hide;
        $window->FORM->{'hseparator67'}->hide;
    };
    
    
    $MyUI=$window;
    $window->TOPLEVEL->set_title('Bankovní účet / pokladna');
    $MyUI->{'TOPFORM'}=$MyUI->FORM->{'vbox121'};
    $MyMoney{'MainCfg'}->window_open("UcetPokladna",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    return($retcode);
};

sub on_button_close_clicked {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("UcetPokladna",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_UcPokl_unrealize {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("UcetPokladna",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {   
    $UcPokl->ReadFromUI($MyUI->FORM);
    if(!$UcPokl->get('zkrat')) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Zkratka nemůže být prázdná!","type"=>"error");
            return;        
    };
    if($MyUI->{'where'}) {
        if(!$UcPokl->update) {
            return;
        };
    } else {
        if(!$UcPokl->save(1)) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Záznam nelze uložit!\nZřejmě ukládáte duplicitní klíč.","type"=>"error");
            return;
        };
    };
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("UcetPokladna",$MyUI->TOPLEVEL);
    $retcode=$UcPokl;
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_ucpokl_toggled {
    if($MyUI->FORM->{'ucpokl_U'}->get_active) {
        $MyUI->FORM->{'table83'}->set_sensitive(1);
        $MyUI->FORM->{'hbox248'}->set_sensitive(0);
    } else {  
        $MyUI->FORM->{'table83'}->set_sensitive(0);
        $MyUI->FORM->{'hbox248'}->set_sensitive(1);
    };
};

sub on_button_bkod_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('banky',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"kod","selected_rows"=>[$MyUI->FORM->{'bkod'}->get_text])) {
        my $tbl=new Table('g_Banky',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'bkod'}->set_text($tbl->get('kod'));
                $MyUI->FORM->{'bnazev'}->set_text($tbl->get('nazev'));
                $MyUI->FORM->{'bzkrat'}->set_text($tbl->get('zkrat'));
                $MyUI->FORM->{'swift'}->set_text($tbl->get('swift'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'bkod'}->set_text('');
            $MyUI->FORM->{'bnazev'}->set_text('');
            $MyUI->FORM->{'bzkrat'}->set_text('');
            $MyUI->FORM->{'swift'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub  on_button_primucet_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('uctova_osnova',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"ucet","selected_rows"=>[$MyUI->FORM->{'primucet'}->get_text])) {
        my $tbl=new Table('r_UcOsnova',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'primucet'}->set_text($tbl->get('ucet'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'primucet'}->set_text('000000');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

1;
