#!/usr/bin/perl -w

package UcetUctoveOsnovy;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;

use lib "./";
use lib::Dialog;
use lib::Locks;
use lib::Databaze;

my $MyUI;
my %MyMoney;
my $retcode="";
my $UcetUctoveOsnovy;
my $Locks;

sub upravit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    my $dissable_ok=0;
    $Locks=0;
    if($where) {
        $Locks=new Locks(%MyMoney);
        if(!$Locks->create_lock('r_UcOsnova',$where)) {
            $dissable_ok=1;
        };
    };
    return($self->run($dissable_ok, $where,0,%params));
};

sub kopirovat {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    return($self->run(0, $where,1,%params));
};

sub pridat {
    my ($self, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    return($self->run(0,'',0,%params));
};

sub odstranit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('r_UcOsnova',$where,1)) {
        return(0);
    };
    my $Databaze=new Databaze(%MyMoney);
    if(!$Databaze->Remove("r".$MyMoney{'RokData'}->get('id')."_UcOsnova",$where)) {
        $Locks->remove_lock;
        return(0);
    };
    $Locks->remove_lock;
    return(1);
};

sub run {
    my ($class, $dissable_ok, $where, $kopie, %params) = @_;
    $retcode=0;
    %MyMoney=%params;
    my $window=$class;
    $MyUI=$class;
    $UcetUctoveOsnovy=new Table('r_UcOsnova',%MyMoney);
    if(!$kopie) {
        $class->{'where'}=$where;
    } else {
        $class->{'where'}="";
    };
    if($dissable_ok) {
        $window->FORM->{'button_ok'}->set_sensitive(0);
    };

    if($where) {
        if(!$UcetUctoveOsnovy->load($where,1)) {
            my $Dialog=new Dialog;
            $Dialog->show("text"=>"Záznam nelze načíst!\nZřejme byl změněn jiným uživatelem.","type"=>"error");
            if($Locks) {
                $Locks->remove_lock;
            };
            return(0);
        };
    };
    $UcetUctoveOsnovy->WriteToUI($window->FORM);
    $MyUI->typ_uctu_changed;
    
    $MyUI=$window;
    $window->TOPLEVEL->set_title('Účet účtové osnovy');
    $MyMoney{'MainCfg'}->window_open("UcetUctoveOsnovy",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    return($retcode);
};

sub on_button_close_clicked {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("UcetUctoveOsnovy",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_UcetUctoveOsnovy_unrealize {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("UcetUctoveOsnovy",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {   
    $UcetUctoveOsnovy->ReadFromUI($MyUI->FORM);
    if(!$UcetUctoveOsnovy->get('ucet')) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Účet nemůže být prázdný!","type"=>"error");
            return;        
    };

    if($MyUI->{'where'}) {
        if(!$UcetUctoveOsnovy->update) {
            return;
        };
    } else {
        if(!$UcetUctoveOsnovy->save(1)) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Záznam nelze uložit!\nZřejmě ukládáte duplicitní klíč.","type"=>"error");
            return;
        };
    };
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("UcetUctoveOsnovy",$MyUI->TOPLEVEL);
    $retcode=$UcetUctoveOsnovy;
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub typ_uctu_changed {
    if($MyUI->FORM->{'druhuctu_R'}->get_active) {
        $MyUI->FORM->{'ucettyp'}->show;
        if($MyUI->FORM->{'ucettyp'}->get_history>1) {
            $MyUI->FORM->{'ucettyp'}->set_history(0);
        };
        if($MyUI->FORM->{'ucetpodtyp'}->get_history>1) {
            $MyUI->FORM->{'ucetpodtyp'}->set_history(0);
        };

        $MyUI->FORM->{'item164'}->show;
        $MyUI->FORM->{'item165'}->show;
        $MyUI->FORM->{'item166'}->hide;
        $MyUI->FORM->{'item167'}->hide;
        $MyUI->FORM->{'item168'}->show;
        $MyUI->FORM->{'item169'}->show;
        $MyUI->FORM->{'item170'}->hide;
        $MyUI->FORM->{'item171'}->hide;
        $MyUI->FORM->{'item172'}->hide;
        $MyUI->FORM->{'item173'}->hide;
        $MyUI->FORM->{'vbox167'}->show_all;
    };
    if($MyUI->FORM->{'druhuctu_V'}->get_active) {
        $MyUI->FORM->{'ucettyp'}->show;
        if($MyUI->FORM->{'ucettyp'}->get_history<2) {
            $MyUI->FORM->{'ucettyp'}->set_history(2);
        };
        if(($MyUI->FORM->{'ucetpodtyp'}->get_history<2) || ($MyUI->FORM->{'ucetpodtyp'}->get_history>3)) {
            $MyUI->FORM->{'ucetpodtyp'}->set_history(2);
        };
        $MyUI->FORM->{'item164'}->hide;
        $MyUI->FORM->{'item165'}->hide;
        $MyUI->FORM->{'item166'}->show;
        $MyUI->FORM->{'item167'}->show;
        $MyUI->FORM->{'item168'}->hide;
        $MyUI->FORM->{'item169'}->hide;
        $MyUI->FORM->{'item170'}->show;
        $MyUI->FORM->{'item171'}->show;
        $MyUI->FORM->{'item172'}->hide;
        $MyUI->FORM->{'item173'}->hide;
        $MyUI->FORM->{'vbox167'}->show_all;
        $MyUI->FORM->{'opravky'}->hide;
    };
    if(($MyUI->FORM->{'druhuctu_Z'}->get_active) || ($MyUI->FORM->{'druhuctu_P'}->get_active)) {
        $MyUI->FORM->{'ucettyp'}->hide;
        if($MyUI->FORM->{'ucetpodtyp'}->get_history<4) {
            $MyUI->FORM->{'ucetpodtyp'}->set_history(4);
        };
        $MyUI->FORM->{'item168'}->hide;
        $MyUI->FORM->{'item169'}->hide;
        $MyUI->FORM->{'item170'}->hide;
        $MyUI->FORM->{'item171'}->hide;
        $MyUI->FORM->{'item172'}->show;
        $MyUI->FORM->{'item173'}->show;
        $MyUI->FORM->{'vbox167'}->hide;
    };
    if($MyUI->FORM->{'ucettyp'}->get_history eq 1) {
        $MyUI->FORM->{'opravky'}->set_sensitive(0);
    } else {
        $MyUI->FORM->{'opravky'}->set_sensitive(1);
    };
};

1;
